// BAMBE.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BAMBE.h"
#include "CloseWins.h"

#include "DisplayParam.h"
#include "DisplayFile.h"
#include "parfile.h"
#include "summarize.h"
#include "estparams.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "OutFrm.h"
#include "TopFrm.h"
#include "KapFrm.h"
#include "Kap2Frm.h"
#include "LpdFrm.h"
#include "Lpd2Frm.h"
#include "TreFrm.h"
#include "KarFrm.h"
#include "SUMFrm.h"
#include "THEFrm.h"
#include "FILEFrm.h"
#include "TTPFrm.h"
#include "GAMFrm.h"

#include "BAMBEDoc.h"
#include "BAMBEView.h"

#include "OUTView.h"
#include "TOPView.h"
#include "KAPView.h"
#include "KAP2View.h"
#include "LPDView.h"
#include "LPD2View.h"
#include "TREView.h"
#include "KARView.h"
#include "SUMView.h"
#include "ESTView.h"
#include "THEView.h"
#include "FILEView.h"
#include "TTPView.h"
#include "GAMView.h"

#include "GenDoc.h"

#include "Splash.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CBAMBEApp

BEGIN_MESSAGE_MAP(CBAMBEApp, CWinApp)
	//{{AFX_MSG_MAP(CBAMBEApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_OUTPUT_DISPLAYOUT, OnOutputDisplayout)
	ON_UPDATE_COMMAND_UI(ID_OUTPUT_DISPLAYOUT, OnUpdateOutputDisplayout)
	ON_COMMAND(ID_OUTPUT_SUMMARIZE, OnOutputSummarize)
	ON_UPDATE_COMMAND_UI(ID_OUTPUT_SUMMARIZE, OnUpdateOutputSummarize)
	ON_COMMAND(ID_OUTPUT_ESTIMATE, OnOutputEstimate)
	ON_UPDATE_COMMAND_UI(ID_OUTPUT_ESTIMATE, OnUpdateOutputEstimate)
	ON_COMMAND(ID_OUTPUT_DIS_OUT_FILE, OnOutputDisOutFile)
	ON_UPDATE_COMMAND_UI(ID_OUTPUT_DIS_OUT_FILE, OnUpdateOutputDisOutFile)
	ON_COMMAND(ID_CLOSEALLWINS, OnCloseallwins)
	ON_UPDATE_COMMAND_UI(ID_CLOSEALLWINS, OnUpdateCloseallwins)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBAMBEApp construction

CBAMBEApp::CBAMBEApp()
{
	pBApp = this;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBAMBEApp object

CBAMBEApp theApp;


/////////////////////////////////////////////////////////////////////////////
// Bug fix # 23 
#if _MFC_VER == 0x400 

     static inline BOOL IsDirSep(TCHAR ch) { 
         return (ch == _T('\\') || ch == _T('/'));
     } 

     #ifndef _MAC 
		BOOL AFXAPI AfxResolveShortcut(CWnd* pWnd, LPCTSTR pszShortcutFile, LPTSTR pszPath, int cchPath);

     #endif 

     #define _countof(array) (sizeof(array)/sizeof(array[0]))

     BOOL AFXAPI AfxFullPath(LPTSTR lpszPathOut, LPCTSTR lpszFileIn); 

     void AFXAPI AfxGetRoot(LPCTSTR lpszPath, CString& strRoot);

     class CMyDocManager : public CDocManager { public: 

         CMyDocManager() {};
         virtual ~CMyDocManager() {};
         virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName);

     }; 

     CDocument* CMyDocManager::OpenDocumentFile(LPCTSTR lpszFileName) { 

         // find the highest confidence
         POSITION pos = m_templateList.GetHeadPosition();
         CDocTemplate::Confidence bestMatch = CDocTemplate::noAttempt;
         CDocTemplate* pBestTemplate = NULL;
         CDocument* pOpenDocument = NULL;

         TCHAR szPath[_MAX_PATH];
         ASSERT(lstrlen(lpszFileName) < _countof(szPath));

     #ifndef _MAC 

         TCHAR szTemp[_MAX_PATH];
         if (lpszFileName[0] == '\"')
             ++lpszFileName;
         lstrcpyn(szTemp, lpszFileName, _MAX_PATH);
         LPTSTR lpszLast = _tcsrchr(szTemp, '\"');
         if (lpszLast != NULL)
             *lpszLast = 0;
         AfxFullPath(szPath, szTemp);
         TCHAR szLinkName[_MAX_PATH];

         // CHANGE: check the windows version before calling AfxResolveShortcut
         if((BYTE)GetVersion() >=4 && AfxResolveShortcut(AfxGetMainWnd(),szPath, szLinkName,_MAX_PATH))
             lstrcpy(szPath, szLinkName);

     #else 

         lstrcpyn(szPath, lpszFileName, _MAX_PATH);
         WIN32_FIND_DATA fileData;
         HANDLE hFind = FindFirstFile(lpszFileName, &fileData);
         if (hFind != INVALID_HANDLE_VALUE)
             VERIFY(FindClose(hFind));
         else
             fileData.dwFileType = 0;    // won't match any type

     #endif 

         while (pos != NULL)
         {
             CDocTemplate* pTemplate =
                       (CDocTemplate*)m_templateList.GetNext(pos);
             ASSERT_KINDOF(CDocTemplate, pTemplate);

             CDocTemplate::Confidence match;
             ASSERT(pOpenDocument == NULL);

     #ifndef _MAC 

             match = pTemplate->MatchDocType(szPath, pOpenDocument);

     #else 

             match = pTemplate->MatchDocType(szPath,
                              fileData.dwFileType, pOpenDocument);

     #endif 

             if (match > bestMatch)
             {
                 bestMatch = match;
                 pBestTemplate = pTemplate;
             }
             if (match == CDocTemplate::yesAlreadyOpen)
                 break;      // stop here
         }

         if (pOpenDocument != NULL)
         {
             POSITION pos = pOpenDocument->GetFirstViewPosition();
             if (pos != NULL)
             {
                 CView* pView = pOpenDocument->GetNextView(pos);
                 // get first one
                 ASSERT_VALID(pView);
                 CFrameWnd* pFrame = pView->GetParentFrame();
                 if (pFrame != NULL)
                     pFrame->ActivateFrame();
                 else
                     TRACE0(
                     "Error: Cannot find frame for document to activate.\n");
                 CFrameWnd* pAppFrame;
                 if (pFrame !=
                         (pAppFrame = (CFrameWnd*)AfxGetApp()->m_pMainWnd))
                 {
                     ASSERT_KINDOF(CFrameWnd, pAppFrame);
                     pAppFrame->ActivateFrame();
                 }
             }
             else
             {
                 TRACE0(
                   "Error: Can not find view for document to activate.\n");
             }
             return pOpenDocument;
         }

         if (pBestTemplate == NULL)
         {
             AfxMessageBox(AFX_IDP_FAILED_TO_OPEN_DOC);
             return NULL;
         }

         return pBestTemplate->OpenDocumentFile(szPath);

     } 

     #endif //mfc version 4.0 workaround 

/////////////////////////////////////////////////////////////////////////////
// CBAMBEApp initialization

BOOL CBAMBEApp::InitInstance()
{
	// CG: The following block was added by the Splash Screen component.
\
	{
\
		CCommandLineInfo cmdInfo;
\
		ParseCommandLine(cmdInfo);
\

\
		CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);
\
	}
     #if _MFC_VER == 0x400 
         m_pDocManager = new CMyDocManager;
     #endif 

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CBAMBEDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBAMBEView));
	AddDocTemplate(pDocTemplate);

	m_pTemplateOut = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(COutFrame),
		RUNTIME_CLASS(COUTView));

	m_pTemplateTop = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CTopFrame),
		RUNTIME_CLASS(CTOPView));

	m_pTemplateKap = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CKapFrame),
		RUNTIME_CLASS(CKAPView));

	m_pTemplateLpd = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CLpdFrame),
		RUNTIME_CLASS(CLPDView));

	m_pTemplateLpd2 = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CLpd2Frame),
		RUNTIME_CLASS(CLPD2View));

	m_pTemplateTre = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CTreFrame),
		RUNTIME_CLASS(CTREView));

	m_pTemplateKap2 = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CKap2Frame),
		RUNTIME_CLASS(CKAP2View));

	m_pTemplateKar = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CKarFrame),
		RUNTIME_CLASS(CKARView));

	m_pTemplateSum = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CSUMFrame),
		RUNTIME_CLASS(CSUMView));
	
	m_pTemplateEst = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CSUMFrame),
		RUNTIME_CLASS(CESTView));

	m_pTemplateTheta = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CTHETAFrame),
		RUNTIME_CLASS(CTHETAView));

	m_pTemplateFile = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CFILEFrame),
		RUNTIME_CLASS(CFILEView));

	m_pTemplateTtp = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CTTPFrame),
		RUNTIME_CLASS(CTTPView));

	m_pTemplateGam = new CMultiDocTemplate(
		IDR_BAMBETYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CGAMFrame),
		RUNTIME_CLASS(CGAMView));


	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	pMain = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// DON'T display a new MDI child window during startup!!!
    cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	m_nCmdShow = SW_SHOWMAXIMIZED;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBAMBEApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEApp commands

int CBAMBEApp::ExitInstance() 
{
	delete m_pTemplateOut;	
	delete m_pTemplateTop;
	delete m_pTemplateTre;
	delete m_pTemplateLpd;
	delete m_pTemplateLpd2;
	delete m_pTemplateKap;
	delete m_pTemplateKap2;
	delete m_pTemplateKar;
	delete m_pTemplateSum;
	delete m_pTemplateEst;
	delete m_pTemplateTheta;
	delete m_pTemplateFile;
	delete m_pTemplateTtp;
	delete m_pTemplateGam;

	TRACE("In ExitInstance, Deleted templates\n");

     #if _MFC_VER == 0x400 
         delete m_pDocManager;
     #endif 
	
	return CWinApp::ExitInstance();
}

void CBAMBEApp::OnOutputDisplayout() 
{
	DisplayParam display;
	
	if(display.DoModal() == IDOK) {
	    char *c = new char[display.m_param_file.GetLength()+1];
		strcpy(c, display.m_param_file);
		char *t = new char[display.m_tree_file.GetLength()+1];
		strcpy(t, display.m_tree_file);
		ParamFile params(c,t);

		int bad_tree_file;
		int tree_format = (display.m_ck_TOP ? display.m_tree_format : -1);
		int param_wins = (display.m_ck_KAP || display.m_ck_KAR || display.m_ck_LPD1 || 
			display.m_ck_LPD2 || display.m_ck_TAR || display.m_ck_THETA) ? 1 : 0;
		BOOL ok;

		HCURSOR newCursor, oldCursor;
  
		// Load the predefined Windows "hourglass" cursor.
		newCursor = CWinApp::LoadStandardCursor(IDC_WAIT);	//AfxGetApp()->
		oldCursor = SetCursor(newCursor);		// set the new cursor
		UpdateStatusBar(1);
		
		TRACE("Getting Values\n");
		if(params.GetValues(tree_format, param_wins, bad_tree_file)) {
			if(param_wins) {
				TRACE("Before Parse\n");
				if(display.m_display_int) {
					if(display.m_ck_first && display.m_ck_last) {
						params.Parse(-1, -1);
					}
					else if(display.m_ck_first) {
						params.Parse(0, display.m_end_cycle);
					}
					else if(display.m_ck_last) {
						params.Parse(display.m_begin_cycle, -1);
					}
					else {
						params.Parse(display.m_begin_cycle, display.m_end_cycle);
					}
				}
				else
					params.Parse(-1, -1);

				if (display.m_ck_TAR) {
					ok = pMain->SendMessage(WM_USERNEWKAP, 0,0);
					globals.KapOpen = 1;
					TRACE("Sending message WM_USERNEWKAP %s\n", ok ? "true" : "false");
				}
				if (display.m_ck_LPD2) {
					ok = pMain->SendMessage(WM_USERNEWLPD2, 0,0);
					globals.Lpd2Open = 1;
					TRACE("Sending message WM_USERNEWLPD2 %s\n", ok ? "true" : "false");
				}
				if (display.m_ck_LPD1) {
					ok = pMain->SendMessage(WM_USERNEWLPD, 0,0);
					globals.LpdOpen = 1;
					TRACE("Sending message WM_USERNEWLPD %s\n", ok ? "true" : "false");
				}
				if (display.m_ck_KAP) {
					ok = pMain->SendMessage(WM_USERNEWKAP2, 0,0);
					globals.Kap2Open = 1;
					TRACE("Sending message WM_USERNEWKAP2 %s\n", ok ? "true" : "false");
				}
				if (display.m_ck_KAR) {
					ok = pMain->SendMessage(WM_USERNEWKAR, 0,0);
					globals.KarOpen = 1;
					TRACE("Sending message WM_USERNEWKAR %s\n", ok ? "true" : "false");
				}
				if (display.m_ck_THETA) {
					ok = pMain->SendMessage(WM_USERNEWTHETA, 0,0);
					globals.THETAOpen = 1;
					TRACE("Sending message WM_USERNEWTHETA %s\n", ok ? "true" : "false");
				}
			}
			if (display.m_ck_TOP && !bad_tree_file) {
				ok = pMain->SendMessage(WM_USERNEWTOP, 0,0);
				globals.TopOpen = 1;
				TRACE("Sending message WM_USERNEWTOP %s\n", ok ? "true" : "false");
			}
//			globals.EnableMaximize();	// Doesn't work properly!

		}

		SetCursor(oldCursor);	// reset the old cursor
		UpdateStatusBar(0);

		delete [] c;
		delete [] t;
	}
}

void CBAMBEApp::OnUpdateOutputDisplayout(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(globals.RunAvail);	
}

void CBAMBEApp::OnOutputSummarize() 
{
	CSummarize summary;

	if(summary.DoModal() == IDOK) {
		UpdateStatusBar(1);
		summary.RunSummarize();
		UpdateStatusBar(0);
	}
}

void CBAMBEApp::OnUpdateOutputSummarize(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(globals.RunAvail);	
}

void CBAMBEApp::OnOutputEstimate() 
{
	CEstParams estimate;
	
	if(estimate.DoModal() == IDOK) {
		UpdateStatusBar(1);
		estimate.RunEstimations();
		UpdateStatusBar(0);
	}
}

void CBAMBEApp::OnUpdateOutputEstimate(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(globals.RunAvail);	
}

BOOL CBAMBEApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following lines were added by the Splash Screen component.
	if (CSplashWnd::PreTranslateAppMessage(pMsg))
		return TRUE;

	return CWinApp::PreTranslateMessage(pMsg);
}

void CBAMBEApp::OnOutputDisOutFile() 
{
	CDisplayFile dialogBox;

	if (dialogBox.DoModal() == IDOK) {
		UpdateStatusBar(1);
		dialogBox.ReadFile();
		UpdateStatusBar(0);
	}
}

void CBAMBEApp::UpdateStatusBar(int msg)
{
	CString RunMssg;
	RunMssg.Format("Reading input files. . .");
	
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CStatusBar* pStatus = &pFrame->m_wndStatusBar;
	if(msg == 1) {
		pStatus->SetPaneText(0, RunMssg);
	}
	else {
		RunMssg += "Done";
		pStatus->SetPaneText(0, RunMssg);
	}
}

void CBAMBEApp::OnUpdateOutputDisOutFile(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CBAMBEApp::OnCloseallwins() 
{
	CCloseWins printmssg;
	int ans = printmssg.DoModal();

	if(ans == IDOK)
		pBApp->globals.CloseAllWins();
}

void CBAMBEApp::OnUpdateCloseallwins(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(globals.CheckWindowStatus());
}
