// BAMBEDoc.cpp : implementation of the CBAMBEDoc class
//

#include "stdafx.h"
#include "BAMBE.h"
#include "BAMBEDoc.h"
#include "NewFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CBAMBEDoc

IMPLEMENT_DYNCREATE(CBAMBEDoc, CDocument)

BEGIN_MESSAGE_MAP(CBAMBEDoc, CDocument)
	//{{AFX_MSG_MAP(CBAMBEDoc)
	ON_COMMAND(ID_EDIT_INIT_VALUES, OnEditInitValues)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBAMBEDoc construction/destruction

CBAMBEDoc::CBAMBEDoc()
{
	pBApp->globals.modify = 0;
	pBApp->globals.IsStop = FALSE;
	pBApp->globals.IsPause = FALSE;
}

CBAMBEDoc::~CBAMBEDoc()
{
}

BOOL CBAMBEDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	pBApp->globals.initialized = 0;
	pBApp->globals.go = 0;
	pBApp->globals.IsChange = 0;
	pBApp->globals.DidRun = 0;
	pBApp->globals.init_tree = 0;
	pBApp->globals.ulentered = 0;
	if (DoProb()) {
		m_outArray.SetSize(43);
		AssignStrArray();
		SetModifiedFlag(TRUE);
		pBApp->globals.initialized = 1;
		pBApp->globals.DocIsOpen = TRUE;
		return TRUE;
	}
	else {
		pBApp->globals.DocIsOpen = FALSE;
		return FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEDoc serialization

void CBAMBEDoc::Serialize(CArchive& ar)
{
	int i;

	if (ar.IsStoring())
	{
		ar << m_seed << m_num_cycles << m_sample_interval 
		   << m_param_update_interval<< m_window_interval
		   << m_burn << m_num_tags
		   << m_burn_algorithm << m_main_algorithm
		   << m_single_kappa <<  m_mclock << m_model << m_outgroup
		   << m_update_kappa << m_update_theta << m_update_pi 
		   << m_update_gamma << m_update_ttp << m_estimate_pi;

		ar << m_ttp_tune << m_gamma_tune << m_use_beta << m_beta_tune;

		
		for (i = 0; i < 10; i++) {
			ar << m_input_kappa[i];
			ar << m_input_theta[i];
			ar << m_input_ttp[i];
			ar << m_input_gamma[i];
			ar << m_categories[i];
			ar << m_input_pia[i];
			ar << m_input_pic[i];
			ar << m_input_pig[i];
			ar << m_input_pit[i];
		}
		ar << m_valley_win << m_kappa_win << m_max_depth
		   << m_data_file << m_tree_file << m_file_root 
		   << m_init_tree << m_init_tree_format
		   << m_ShowOutput << m_newick_format << m_tune_interval 
		   << m_cat_list_val << m_userlist << m_num_categories
		   << m_theta_const << m_pi_const;

		ar << m_ShowLPD1 << m_ShowLPD2 << m_ShowKAP << m_ShowKAR
		   << m_ShowTAR <<m_ShowTOP << m_ShowTheta << m_ShowTTP << m_ShowGAM; 

		m_outArray.Serialize(ar);
	}
	else
	{
		m_outArray.SetSize(43);
		ar >> m_seed >>  m_num_cycles >> m_sample_interval 
		   >> m_param_update_interval>> m_window_interval
		   >> m_burn >> m_num_tags
		   >> m_burn_algorithm >> m_main_algorithm
		   >> m_single_kappa >>  m_mclock >> m_model >> m_outgroup
		   >> m_update_kappa >> m_update_theta >> m_update_pi 
		   >> m_update_gamma >> m_update_ttp >> m_estimate_pi;
		
		ar >> m_ttp_tune >> m_gamma_tune >> m_use_beta >> m_beta_tune;

		for (i = 0; i < 10; i++) {
			ar >> m_input_kappa[i];
			ar >> m_input_theta[i];
			ar >> m_input_ttp[i];
			ar >> m_input_gamma[i];
			ar >> m_categories[i];
			ar >> m_input_pia[i];
			ar >> m_input_pic[i];
			ar >> m_input_pig[i];
			ar >> m_input_pit[i];
		}

		ar >> m_valley_win >> m_kappa_win >> m_max_depth
		   >> m_data_file >> m_tree_file >> m_file_root 
		   >> m_init_tree >> m_init_tree_format
		   >> m_ShowOutput >> m_newick_format >> m_tune_interval
		   >> m_cat_list_val >> m_userlist >> m_num_categories
		   >> m_theta_const >> m_pi_const;

		ar >> m_ShowLPD1 >> m_ShowLPD2 >> m_ShowKAP >> m_ShowKAR
		   >> m_ShowTAR >>m_ShowTOP >> m_ShowTheta >> m_ShowTTP >> m_ShowGAM; 

		m_outArray.Serialize(ar);
		SetGlobalVariables();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEDoc diagnostics

#ifdef _DEBUG
void CBAMBEDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBAMBEDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBAMBEDoc commands

int CBAMBEDoc::DoProb()
{
	if(m_pageprob.DoModal() == IDOK) {
		m_pageprob.GetInfoProb();

		return DoModelParam();
	}
	else
		return 0;
}

int CBAMBEDoc::DoModelParam()	// CRunChar2 - IDD_PROP_RCHAR dialog - init. kappa/theta, etc.
{
	int id = m_pageModelParam.DoModal();
	if(id == IDOK) {
		m_pageModelParam.GetInfoModelParam();

		if (!pBApp->globals.estimate_pi) {
			return DoInitPi();
		}
		else {
		// initialize if not called so that garbage isn't saved
			for (int i = 0; i < 10; i++) {
				m_input_pia[i] = pBApp->globals.input_pia[i] = 0.25;
				m_input_pic[i] = pBApp->globals.input_pic[i] = 0.25;
				m_input_pig[i] = pBApp->globals.input_pig[i] = 0.25;
				m_input_pit[i] = pBApp->globals.input_pit[i] = 0.25;
			}
			if (pBApp->globals.model == 2) {
				return DoTNPage();
			}
			else {
			// initialize if not called so that garbage isn't saved
				for (int i = 0; i < 10; i++) {
					m_input_ttp[i] = pBApp->globals.input_ttp[i] = 1;
					m_input_gamma[i] = pBApp->globals.input_gamma[i] = 1;
				}
				return DoRun();
			}
		}
	}
	else if (id == IDC_BACK) {
		return DoProb();
	}
	else
		return 0;
}

int CBAMBEDoc::DoInitPi()
{
	int id = m_page_initpi.DoModal();
	if(id == IDOK) {
		m_page_initpi.GetInfoInitPi();

		if (pBApp->globals.model == 2) {
			return DoTNPage();
		}
		else {
		// initialize if not called so that garbage isn't saved
			for (int i = 0; i < 10; i++) {
				m_input_ttp[i] = pBApp->globals.input_ttp[i] = 1;
				m_input_gamma[i] = pBApp->globals.input_gamma[i] = 1;
			}
			return DoRun();
		}
	}
	else if (id == IDC_BACK) {
		return DoModelParam();
	}
	else
		return 0;
}

int CBAMBEDoc::DoTNPage()
{
	int id = m_pageTN.DoModal();
	if(id == IDOK) {
		m_pageTN.GetInfoTNPage();

		return DoRun();
	}
	else if (id == IDC_BACK) {
		if (!pBApp->globals.estimate_pi) {
			return DoInitPi();
		}
		else {
			return DoModelParam();
		}
	}
	else
		return 0;
}

int CBAMBEDoc::DoRun()		// CRunCharac - IDD_PROP_RCHARAC dialog
{
	int id = m_pagerun.DoModal();
	if(id == IDOK) {
		m_pagerun.GetInfoRun();

		return DoView();
	}
	else if (id == IDC_BACK) {
		if (pBApp->globals.model == 2) {
			return DoTNPage();
		}
		else {
			if(!pBApp->globals.estimate_pi) 
				return DoInitPi();
			else
				return DoModelParam();
		}
	}
	else
		return 0;
}

int CBAMBEDoc::DoView()
{
	int id = m_pageview.DoModal();
	if(id == IDOK) {
		m_pageview.GetInfoView();

		return DoTuningParam();
	}
	else if (id == IDC_BACK) {
			return DoRun();
	}
	else 
		return 0;
}

int CBAMBEDoc::DoTuningParam()
{
	int id = m_pagetune.DoModal();
	if(id == IDOK) {
		m_pagetune.GetInfoTuningParam();

		pBApp->globals.modify = 1;

		SetDocumentVariables();
		return 1;
	}
	else if (id == IDC_BACK) {
			return DoView();
	}
	else 
		return 0;
}

void CBAMBEDoc::OnCloseDocument() 
{
	if (pBApp->globals.DidRun || pBApp->globals.IsStop) 
		pBApp->globals.CloseAllWins();

	pBApp->globals.DocIsOpen = FALSE;
	CDocument::OnCloseDocument();
}

void CBAMBEDoc::AssignStrArray()
{
	CString tmp;
	int i = 0;

	m_outArray[i] = "Seed = ";
	tmp.Format("%d", m_seed);
	m_outArray[i++] += tmp;

	m_outArray[i]= "Burn = "; 
	tmp.Format("%d",m_burn);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Burn Algorithm = ";
	switch(m_burn_algorithm)
	{
	case 0: tmp = "Global"; break;
	case 1: tmp = "Local"; break;
	}
	m_outArray[i++] += tmp;
	
  	m_outArray[i] = "Main Algorithm = ";
	switch(m_main_algorithm)
	{
	case 0: tmp = "Global"; break;
	case 1: tmp = "Local"; break;
	}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Use Beta = ";
	tmp.Format(m_use_beta ? "True" : "False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Cycles = ";
	tmp.Format("%d", m_num_cycles);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Sample Interval = "; 
	tmp.Format("%d", m_sample_interval);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Parameter Update Interval = ";
	tmp.Format("%d", m_param_update_interval);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Update Kappa = ";
	tmp = (m_update_kappa ? "True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Update Theta = ";
	tmp = (m_update_theta ? "True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Update Pi = ";
	tmp = (m_update_pi ? "True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Update TTP = ";
	tmp = (m_update_ttp ? "True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Update Gamma = ";
	tmp = (m_update_gamma ? "True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Tune Interval = ";
	tmp.Format("%d", m_tune_interval);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Window Interval = ";
	tmp.Format("%d", m_window_interval);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Molecular Clock = ";
	tmp = (m_mclock ?"True":"False");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Likelihood Model = ";
	switch (m_model) {
	case 0:	tmp = "HKY85"; break;
	case 1:	tmp ="F84"; break;
	case 2: tmp = "TN93"; break;
	}
	m_outArray[i++] += tmp;

// change to category list
	m_outArray[i] = "Category List = ";
	tmp.Format("%s", m_userlist);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Single Kappa = ";
	tmp = (m_single_kappa ? "True":"False");
	m_outArray[i++] += tmp;

	int j;
	CString tmp2;
	m_outArray[i] = "Initial Kappa = ";
	tmp.Format("%f", m_input_kappa[0]);
    if(!m_single_kappa)
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_kappa[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial Theta = ";
	tmp.Format("%f", m_input_theta[0]);
    for(j=1;j<m_num_categories;j++) {
		 tmp2.Format(", %lf", m_input_theta[j]);
		 tmp += tmp2;
	}
	m_outArray[i++] += tmp;

	m_outArray[i++] = m_estimate_pi ? "Estimate Pi = True" : "Estimate Pi = False";

	m_outArray[i] = "Initial Pi A = ";
	tmp.Format("%lf", m_input_pia[0]);
	if(!m_estimate_pi)
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_pia[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial Pi G = ";
	tmp.Format("%lf", m_input_pig[0]);
	if(!m_estimate_pi)
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_pig[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial Pi C = ";
	tmp.Format("%lf", m_input_pic[0]);
	if(!m_estimate_pi)
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_pic[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial Pi T = ";
	tmp.Format("%lf", m_input_pit[0]);
	if(!m_estimate_pi)
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_pit[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial TTP = ";
	tmp.Format("%lf", m_input_ttp[0]);
    if(!m_single_kappa && (m_model == 2))
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_ttp[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Initial Gamma = ";
	tmp.Format("%lf", m_input_gamma[0]);
    if(!m_single_kappa && (m_model == 2))
		for(j=1;j<m_num_categories;j++) {
			tmp2.Format(", %lf", m_input_gamma[j]);
			tmp += tmp2;
		}
	m_outArray[i++] += tmp;

	m_outArray[i] = "Data File = ";
	m_outArray[i++] += m_data_file;
	
	m_outArray[i] = "Outgroup = ";
	tmp.Format("%d", m_outgroup);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Global Tuning Parameter = ";
	tmp.Format("%lf", m_valley_win);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Local Tuning Parameter = ";
	tmp.Format("%lf", m_beta_tune);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Kappa Tuning Parameter = ";
	tmp.Format("%lf", m_kappa_win);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Theta Tuning Parameter = ";
	tmp.Format("%lf", m_theta_const);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Pi Tuning Parameter = ";
	tmp.Format("%lf", m_pi_const);
	m_outArray[i++] += tmp;

	m_outArray[i] = "TTP Tuning Parameter = ";
	tmp.Format("%lf", m_ttp_tune);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Gamma Tuning Parameter = ";
	tmp.Format("%lf", m_gamma_tune);
	m_outArray[i++] += tmp;
	
	m_outArray[i] = "Max Initial Tree Height = ";
	tmp.Format("%lf", m_max_depth);
	m_outArray[i++] += tmp;

	m_outArray[i] = "Tree File = ";
	m_outArray[i++] += m_tree_file;

	m_outArray[i] = "Input Tree Format = ";
	tmp = (m_init_tree == 3 ? (m_init_tree_format ? "Newick":"Bambe") : "No input file used");
	m_outArray[i++] += tmp;

	m_outArray[i] = "File Root = ";
	m_outArray[i++] += m_file_root;

	m_outArray[i] = "Ouput Tree Format = ";
	tmp = (m_newick_format ? "Newick":"Bambe");
	m_outArray[i++] += tmp;

	m_outArray[i] = "Show Output Windows = ";
	tmp = (m_ShowOutput ? ((m_ShowOutput == 1) ? "All" : "Selected") :"None");
	m_outArray[i++] += tmp;
// Total: 43 elements
}

void CBAMBEDoc::DeleteContents() 
{
	m_outArray.RemoveAll();	
	CDocument::DeleteContents();
}

void CBAMBEDoc::SetGlobalVariables()
{
	pBApp->globals.modify = 0;

	// used to initialize variables when a saved document is opened
	pBApp->globals.seed = m_seed;
	pBApp->globals.num_cycles = m_num_cycles;
	pBApp->globals.sample_interval = m_sample_interval;
	pBApp->globals.param_update_interval = m_param_update_interval;
	pBApp->globals.window_interval = m_window_interval;
	pBApp->globals.burn = m_burn;
	pBApp->globals.num_tags = m_num_tags;
	pBApp->globals.num_categories = m_num_categories;
	pBApp->globals.burn_algorithm = m_burn_algorithm;
	pBApp->globals.main_algorithm = m_main_algorithm;
	pBApp->globals.single_kappa = m_single_kappa;
	pBApp->globals.mclock = m_mclock;
	pBApp->globals.model = m_model;
	pBApp->globals.outgroup = m_outgroup;
	pBApp->globals.tune_interval = m_tune_interval;

	pBApp->globals.update_kappa = m_update_kappa;
	pBApp->globals.update_theta = m_update_theta;
	pBApp->globals.update_pi = m_update_pi;
	pBApp->globals.update_gamma = m_update_theta;
	pBApp->globals.update_ttp = m_update_pi;

	pBApp->globals.estimate_pi = m_estimate_pi;

	for(int i = 0; i < 10; i++) {
		pBApp->globals.input_kappa[i] = m_input_kappa[i];
		pBApp->globals.input_theta[i] = m_input_theta[i];
		pBApp->globals.input_ttp[i] = m_input_ttp[i];
		pBApp->globals.input_gamma[i] = m_input_gamma[i];
		pBApp->globals.categories[i] = m_categories[i];

		pBApp->globals.input_pia[i] = m_input_pia[i];
		pBApp->globals.input_pic[i] = m_input_pic[i];
		pBApp->globals.input_pig[i] = m_input_pig[i];
		pBApp->globals.input_pit[i] = m_input_pit[i];
	}
	pBApp->globals.valley_win = m_valley_win;
	pBApp->globals.kappa_win = m_kappa_win;
	pBApp->globals.max_depth = m_max_depth;
	pBApp->globals.init_tree = m_init_tree;
	pBApp->globals.init_tree_format = m_init_tree_format;
	
	BOOL tree, data;
	
	if (m_init_tree == 3) {
		tree = pBApp->globals.IsValidFile(m_tree_file);
	}
	else 
		tree = TRUE;

	data = pBApp->globals.IsValidFile(m_data_file);

	if (!data) {
		GetNewDataName(m_data_file);	
		pBApp->globals.modify = 1;
	}

	if(!tree) {
		GetNewTreeName(m_tree_file);
		if (pBApp->globals.init_tree == 0)
			m_init_tree = 0;
		pBApp->globals.modify = 1;
	}

	strcpy(pBApp->globals.tree_file, m_tree_file);
	strcpy(pBApp->globals.data_file, m_data_file);
	strcpy(pBApp->globals.file_root, m_file_root); 

	pBApp->globals.userlist = m_userlist;
	pBApp->globals.cat_list_val = m_cat_list_val;
	strcpy(pBApp->globals.category_list,pBApp->globals.userlist);

	pBApp->globals.theta_const = m_theta_const;
	pBApp->globals.pi_const = m_pi_const;

	pBApp->globals.gamma_tune = m_gamma_tune;
	pBApp->globals.ttp_tune = m_ttp_tune;

	pBApp->globals.beta_tune = m_beta_tune;
	pBApp->globals.use_beta = m_use_beta;

	pBApp->globals.ShowOutput = m_ShowOutput;
	pBApp->globals.newick_format = m_newick_format;

	AssignStrArray();
	UpdateAllViews(NULL, 0, NULL);
	pBApp->globals.initialized = 1;

	pBApp->globals.ShowLPD1 = m_ShowLPD1;
	pBApp->globals.ShowLPD2 = m_ShowLPD2;
	pBApp->globals.ShowKAP = m_ShowKAP;
	pBApp->globals.ShowKAR = m_ShowKAR;
	pBApp->globals.ShowTAR = m_ShowTAR;
	pBApp->globals.ShowTOP = m_ShowTOP;
	pBApp->globals.ShowTheta = m_ShowTheta; 
	pBApp->globals.ShowTTP = m_ShowTTP;
	pBApp->globals.ShowGAM = m_ShowGAM;
}

void CBAMBEDoc::OnEditInitValues() 
{
	pBApp->globals.IsChange = 1;

	pBApp->globals.firstModelParam = pBApp->globals.firstRun = pBApp->globals.firstTN = pBApp->globals.firstView = pBApp->globals.firstInitPi = pBApp->globals.firstTune = 0;
	if (DoProb()) {
		AssignStrArray();
		SetModifiedFlag(TRUE);
		pBApp->globals.initialized = 1;
	}
	else {
		ResetVariables();
	}
	UpdateAllViews(NULL, 0, NULL);
	pBApp->globals.IsChange = 0;
}

void CBAMBEDoc::OnFileSave() 
{
	CDocument::OnFileSave();
	//SetModifiedFlag(FALSE);	
	
	if (!IsModified())
		pBApp->globals.modify = 0;
}

void CBAMBEDoc::ResetVariables()
{
	pBApp->globals.seed = m_seed;
	pBApp->globals.num_cycles = m_num_cycles;
	pBApp->globals.sample_interval = m_sample_interval;
	pBApp->globals.param_update_interval = m_param_update_interval;
	pBApp->globals.window_interval = m_window_interval;
	pBApp->globals.burn = m_burn;
	pBApp->globals.num_tags = m_num_tags;
	pBApp->globals.num_categories = m_num_categories;
	pBApp->globals.burn_algorithm = m_burn_algorithm;
	pBApp->globals.main_algorithm = m_main_algorithm;
	pBApp->globals.single_kappa = m_single_kappa;
	pBApp->globals.mclock = m_mclock;
	pBApp->globals.model = m_model;
	pBApp->globals.outgroup = m_outgroup;
	pBApp->globals.tune_interval = m_tune_interval;

	pBApp->globals.update_kappa = m_update_kappa;
	pBApp->globals.update_theta = m_update_theta;
	pBApp->globals.update_pi = m_update_pi;
	pBApp->globals.update_gamma = m_update_theta;
	pBApp->globals.update_ttp = m_update_pi;

	pBApp->globals.estimate_pi = m_estimate_pi;

	for(int i = 0; i < 10; i++) {
		pBApp->globals.input_kappa[i] = m_input_kappa[i];
		pBApp->globals.input_theta[i] = m_input_theta[i];
		pBApp->globals.input_ttp[i] = m_input_ttp[i];
		pBApp->globals.input_gamma[i] = m_input_gamma[i];
		pBApp->globals.categories[i] = m_categories[i];

		pBApp->globals.input_pia[i] = m_input_pia[i];
		pBApp->globals.input_pic[i] = m_input_pic[i];
		pBApp->globals.input_pig[i] = m_input_pig[i];
		pBApp->globals.input_pit[i] = m_input_pit[i];
	}
	pBApp->globals.valley_win = m_valley_win;
	pBApp->globals.kappa_win = m_kappa_win;
	pBApp->globals.max_depth = m_max_depth;
	pBApp->globals.init_tree = m_init_tree;
	pBApp->globals.init_tree_format = m_init_tree_format;
	
	strcpy(pBApp->globals.tree_file, m_tree_file);
	strcpy(pBApp->globals.data_file, m_data_file);
	strcpy(pBApp->globals.file_root, m_file_root); 

	pBApp->globals.userlist = m_userlist;
	pBApp->globals.cat_list_val = m_cat_list_val;
	strcpy(pBApp->globals.category_list, pBApp->globals.userlist);

	pBApp->globals.theta_const = m_theta_const;
	pBApp->globals.pi_const = m_pi_const;
	pBApp->globals.gamma_tune = m_gamma_tune;
	pBApp->globals.ttp_tune = m_ttp_tune;

	pBApp->globals.beta_tune = m_beta_tune;
	pBApp->globals.use_beta = m_use_beta;

	pBApp->globals.ShowOutput = m_ShowOutput;
	pBApp->globals.newick_format = m_newick_format;

	pBApp->globals.ShowLPD1 = m_ShowLPD1;
	pBApp->globals.ShowLPD2 = m_ShowLPD2;
	pBApp->globals.ShowKAP = m_ShowKAP;
	pBApp->globals.ShowKAR = m_ShowKAR;
	pBApp->globals.ShowTAR = m_ShowTAR;
	pBApp->globals.ShowTOP = m_ShowTOP;
	pBApp->globals.ShowTheta = m_ShowTheta; 
	pBApp->globals.ShowTTP = m_ShowTTP;
	pBApp->globals.ShowGAM = m_ShowGAM;
}

void CBAMBEDoc::SetDocumentVariables()
{
	m_seed = pBApp->globals.seed;
	m_num_cycles = pBApp->globals.num_cycles;
	m_sample_interval = pBApp->globals.sample_interval;
	m_param_update_interval =pBApp->globals.param_update_interval;
	m_window_interval = pBApp->globals.window_interval;
	m_burn = pBApp->globals.burn;
	m_num_tags = pBApp->globals.num_tags;
	m_num_categories = pBApp->globals.num_categories;
	m_burn_algorithm = pBApp->globals.burn_algorithm;
	m_main_algorithm = pBApp->globals.main_algorithm;
	m_single_kappa = pBApp->globals.single_kappa;
	m_mclock = pBApp->globals.mclock;
	m_model = pBApp->globals.model;
	m_outgroup = pBApp->globals.outgroup;
	m_tune_interval = pBApp->globals.tune_interval;

	m_update_kappa = pBApp->globals.update_kappa;
	m_update_theta = pBApp->globals.update_theta;
	m_update_pi = pBApp->globals.update_pi;
	m_update_gamma = pBApp->globals.update_theta;
	m_update_ttp = pBApp->globals.update_pi;

	m_estimate_pi = pBApp->globals.estimate_pi;

	for(int i = 0; i < 10; i++) {
		m_input_kappa[i] = pBApp->globals.input_kappa[i];
		m_input_theta[i] = pBApp->globals.input_theta[i];
		m_input_ttp[i] = pBApp->globals.input_ttp[i];
		m_input_gamma[i] = pBApp->globals.input_gamma[i];
		m_categories[i] = pBApp->globals.categories[i];

		m_input_pia[i] = pBApp->globals.input_pia[i];
		m_input_pic[i] = pBApp->globals.input_pic[i];
		m_input_pig[i] = pBApp->globals.input_pig[i];
		m_input_pit[i] = pBApp->globals.input_pit[i];
	}
	m_valley_win = pBApp->globals.valley_win;
	m_kappa_win = pBApp->globals.kappa_win;
	m_max_depth = pBApp->globals.max_depth;
	m_init_tree = pBApp->globals.init_tree;
	m_init_tree_format = pBApp->globals.init_tree_format;
	m_ShowOutput = pBApp->globals.ShowOutput;
	m_newick_format = pBApp->globals.newick_format;

	m_theta_const = pBApp->globals.theta_const;
	m_pi_const = pBApp->globals.pi_const;
	
	m_gamma_tune = pBApp->globals.gamma_tune;
	m_ttp_tune = pBApp->globals.ttp_tune;

	m_beta_tune = pBApp->globals.beta_tune ;
	m_use_beta = pBApp->globals.use_beta ;

	m_data_file.Format("%s", pBApp->globals.data_file);
	m_tree_file.Format("%s", pBApp->globals.tree_file);
	m_file_root.Format("%s", pBApp->globals.file_root);

	m_userlist = pBApp->globals.userlist;		//.Format("%s", userlist);
	m_cat_list_val = pBApp->globals.cat_list_val;

	m_ShowLPD1 = pBApp->globals.ShowLPD1;
	m_ShowLPD2 = pBApp->globals.ShowLPD2;
	m_ShowKAP = pBApp->globals.ShowKAP;
	m_ShowKAR = pBApp->globals.ShowKAR;
	m_ShowTAR = pBApp->globals.ShowTAR;
	m_ShowTOP = pBApp->globals.ShowTOP;
	m_ShowTheta = pBApp->globals.ShowTheta; 
	m_ShowTTP = pBApp->globals.ShowTTP;
	m_ShowGAM = pBApp->globals.ShowGAM;
}



BOOL CBAMBEDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName)) {
		pBApp->globals.DocIsOpen = FALSE;
		return FALSE;
	}

	pBApp->globals.DocIsOpen = TRUE;	
	return TRUE;
}
