// BAMBEDoc.h : interface of the CBAMBEDoc class
//
/////////////////////////////////////////////////////////////////////////////

#include "Property.h"
#include "TNPage.h"
#include "InitPi.h"
#include "TuningParam.h"

void CloseAllWins();

class CBAMBEDoc : public CDocument
{
public:
	void AssignStrArray();
	CStringArray m_outArray;
	CProbModel m_pageprob;
	CRunCharac m_pagerun;
	CModelParam m_pageModelParam;
	CViewCharac m_pageview;
	CTNPage m_pageTN;
	CInitPi m_page_initpi;
	CTuningParam m_pagetune;

//variables - for serialization
public:
	unsigned int m_seed;

	int 
		m_num_cycles, m_sample_interval, 
		m_param_update_interval, m_window_interval,
		m_burn, m_num_tags, m_num_categories,
		m_burn_algorithm, m_main_algorithm,
		m_single_kappa, m_mclock, m_model, m_outgroup;

	int m_init_tree, m_init_tree_format,
		m_update_kappa, m_update_theta, m_update_pi, 
		m_update_ttp, m_update_gamma, m_estimate_pi, 
		m_newick_format, m_tune_interval, m_cat_list_val, m_use_beta;

	int m_categories[10];

	double 
		m_input_kappa[10], 
		m_input_theta[10], 
		m_input_ttp[10],
		m_input_gamma[10],
		m_valley_win,				// initial delta 
		m_kappa_win,				// initial kappa delta 
		m_max_depth,				// max initial tree height
		m_theta_const, m_pi_const,
		m_ttp_tune, m_gamma_tune, m_beta_tune;

	double 
		m_input_pia[10], m_input_pic[10], m_input_pig[10], m_input_pit[10];

	CString
		m_data_file, m_tree_file, m_file_root, m_userlist;

	BOOL m_ShowOutput;

	int m_ShowLPD1, m_ShowLPD2, m_ShowKAP, m_ShowKAR, m_ShowTAR, 
		m_ShowTOP, m_ShowTheta, m_ShowTTP, m_ShowGAM; 

protected: // create from serialization only
	CBAMBEDoc();
	DECLARE_DYNCREATE(CBAMBEDoc)


// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBAMBEDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBAMBEDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	void SetDocumentVariables();
	void ResetVariables();
	//{{AFX_MSG(CBAMBEDoc)
	afx_msg void OnEditInitValues();
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void SetGlobalVariables();
	int DoView();
	int DoRun();
	int DoModelParam();
	int DoProb();
	int DoTNPage();
	int DoInitPi();
	int DoTuningParam();
};

/////////////////////////////////////////////////////////////////////////////
