// BAMBEView.cpp : implementation of the CBAMBEView class
//

#include "stdafx.h"
#include "BAMBE.h"

#include "BAMBEDoc.h"
#include "BAMBEView.h"
#include "MainFrm.h"
#include "CloseWins.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CBAMBEView

IMPLEMENT_DYNCREATE(CBAMBEView, CLogScrollView)

BEGIN_MESSAGE_MAP(CBAMBEView, CLogScrollView)
	//{{AFX_MSG_MAP(CBAMBEView)
	ON_COMMAND(ID_RUN_RUN, OnRunRun)
	ON_UPDATE_COMMAND_UI(ID_RUN_RUN, OnUpdateRunRun)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_EDIT_INIT_VALUES, OnUpdateEditInitValues)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSE, OnUpdateFileClose)
	ON_COMMAND(ID_RUN_STOP, OnRunStop)
	ON_UPDATE_COMMAND_UI(ID_RUN_STOP, OnUpdateRunStop)
	ON_COMMAND(ID_CLOSEALLWINS, OnCloseAllWins)
	ON_UPDATE_COMMAND_UI(ID_CLOSEALLWINS, OnUpdateCloseAllWins)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(ID_RUN_PAUSE, OnRunPause)
	ON_UPDATE_COMMAND_UI(ID_RUN_PAUSE, OnUpdateRunPause)
	ON_COMMAND(ID_RUN_RESUME, OnRunResume)
	ON_UPDATE_COMMAND_UI(ID_RUN_RESUME, OnUpdateRunResume)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USERSTATUS, OnUserStatus)
	ON_MESSAGE(WM_USERCHILDRUN, OnUserChildRun)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CLogScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CLogScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CLogScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBAMBEView construction/destruction

CBAMBEView::CBAMBEView()
{
	pBApp->globals.g_pView = this;
	pBApp->globals.OutOpen = 0;
	pBApp->globals.TopOpen = 0;
	pBApp->globals.KapOpen = 0;
	pBApp->globals.Kap2Open = 0;
	pBApp->globals.LpdOpen = 0;
	pBApp->globals.Lpd2Open = 0;
	pBApp->globals.TreOpen = 0;
	pBApp->globals.KarOpen = 0;
	pBApp->globals.THETAOpen = 0;
	pBApp->globals.TTPOpen = 0;
	pBApp->globals.GAMOpen = 0;
}

CBAMBEView::~CBAMBEView()
{
}

BOOL CBAMBEView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CLogScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEView drawing

void CBAMBEView::OnDraw(CDC* pDC)
{
	CBAMBEDoc* pDoc = GetDocument();
	if (pBApp->globals.modify)
		pDoc->SetModifiedFlag(TRUE);
	
	int        i, j, nHeight;
	CFont      font;
	TEXTMETRIC tm;

	//  use 10-point roman font
	font.CreateFont(-200, 0, 0, 0, 400, FALSE, FALSE, 0, ANSI_CHARSET,
	                OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
	                DEFAULT_QUALITY, DEFAULT_PITCH | FF_ROMAN,
	                "Times New Roman");
	CFont* pOldFont = (CFont*) pDC->SelectObject(&font);
	pDC->GetTextMetrics(&tm);
	nHeight = tm.tmHeight + tm.tmExternalLeading;

	int header = 0, indent = 0;
	if (pDC->IsPrinting()) {
		PrintHeader(pDC);
		header = -350 - nHeight; 
		indent = 100;
	}

	j = pDoc->m_outArray.GetSize();
	for (i = 0; i < j; i++) {
		pDC->TextOut(100 + indent, -i * nHeight - 100 + header, 
			pDoc->m_outArray[i]);
	}
	pDC->SelectObject(pOldFont);
}

void CBAMBEView::PrintHeader(CDC * pDC)
{
	CString tmp;

	CBAMBEDoc* pDoc = GetDocument();
	tmp.Format("%s     -     Parameter List", (LPCSTR) pDoc->GetTitle());
	CFont* pPreviousFont = pDC->SelectObject(GetFont());
	pDC->TextOut(20, -150, tmp);

	if(pPreviousFont) {
		pDC->SelectObject(pPreviousFont);
	}
}


void CBAMBEView::OnInitialUpdate()
{
	CLogScrollView::OnInitialUpdate();
	CSize sizeTotal;

	sizeTotal.cx = 11520;	// 11520
	sizeTotal.cy = 11000;	// 15120
	SetLogScrollSizes(sizeTotal);
	pBApp->globals.g_BViewHwnd = GetSafeHwnd();
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEView printing

BOOL CBAMBEView::OnPreparePrinting(CPrintInfo* pInfo)
{
	pInfo->SetMaxPage(1);
	return DoPreparePrinting(pInfo);
}

void CBAMBEView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBAMBEView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CBAMBEView diagnostics

#ifdef _DEBUG
void CBAMBEView::AssertValid() const
{
	CLogScrollView::AssertValid();
}

void CBAMBEView::Dump(CDumpContext& dc) const
{
	CLogScrollView::Dump(dc);
}

CBAMBEDoc* CBAMBEView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBAMBEDoc)));
	return (CBAMBEDoc*)m_pDocument;
}
#endif //_DEBUG

LRESULT CBAMBEView::OnUserStatus(WPARAM wParam, LPARAM lParam)
{
	CString RunMssg;
	RunMssg.Format("Processing information. . .");
	
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CStatusBar* pStatus = &pFrame->m_wndStatusBar;
	if(pStatus) {
		pStatus->SetPaneText(0, RunMssg);
	}

	if(pBApp->globals.RunAvail) {
		RunMssg += "Done";
		pStatus->SetPaneText(0, RunMssg);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CBAMBEView message handlers

void CBAMBEView::OnRunRun() 
{  
	pBApp->globals.RunAvail = FALSE;
	pBApp->globals.IsStop = FALSE;

		if (pBApp->globals.OutOpen)
			::SendMessage(pBApp->globals.g_OutHwnd, WM_USERCLOSEOUT, 0,0);
		if (pBApp->globals.TopOpen)
			::SendMessage(pBApp->globals.g_TopHwnd, WM_USERCLOSETOP, 0,0);
		if (pBApp->globals.KapOpen)
			::SendMessage(pBApp->globals.g_KapHwnd, WM_USERCLOSEKAP, 0,0);
		if (pBApp->globals.Kap2Open)
			::SendMessage(pBApp->globals.g_Kap2Hwnd, WM_USERCLOSEKAP2, 0,0);
		if (pBApp->globals.LpdOpen)
			::SendMessage(pBApp->globals.g_LpdHwnd, WM_USERCLOSELPD, 0,0);
		if (pBApp->globals.Lpd2Open)
			::SendMessage(pBApp->globals.g_Lpd2Hwnd, WM_USERCLOSELPD2, 0,0);
		if (pBApp->globals.TreOpen)
			::SendMessage(pBApp->globals.g_TreHwnd, WM_USERCLOSETRE, 0,0);
		if (pBApp->globals.KarOpen)
			::SendMessage(pBApp->globals.g_KarHwnd, WM_USERCLOSEKAR, 0,0);
		if (pBApp->globals.THETAOpen)
			::SendMessage(pBApp->globals.g_THETAHwnd, WM_USERCLOSETHETA, 0,0);
		if (pBApp->globals.KarOpen)
			::SendMessage(pBApp->globals.g_TTPHwnd, WM_USERCLOSETTP, 0,0);
		if (pBApp->globals.THETAOpen)
			::SendMessage(pBApp->globals.g_GAMHwnd, WM_USERCLOSEGAM, 0,0);

	pBApp->globals.DidRun = 0;

	AfxBeginThread(McmcThread,0, THREAD_PRIORITY_NORMAL);
}

void CBAMBEView::OnRunStop() 
{
	pBApp->globals.IsStop = TRUE;
	pBApp->globals.RunAvail = TRUE;
	pBApp->globals.IsPause = FALSE;
}

void CBAMBEView::OnUpdateRunRun(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.RunAvail && pBApp->globals.DocIsOpen);	
}

LRESULT CBAMBEView::OnUserChildRun(WPARAM wParam, LPARAM lParam)
{
	OnRunRun();

	return TRUE;
}

UINT McmcThread(LPVOID param)
{
	pBApp->globals.g_pView->SendMessage(WM_USERSTATUS);

	CallMain();

	pBApp->globals.RunAvail = TRUE;
	pBApp->globals.g_pView->SendMessage(WM_USERSTATUS);

	if (pBApp->globals.ShowOutput == 0) {
		 CString mssg;
		 mssg.Format("Program has finished execution.");
		 AfxMessageBox (mssg, MB_OK, 0);
	}

	TRACE("End of thread\n");
	return 0;
}

void UpdateWindows()
{
  	if (pBApp->globals.OutOpen)
	    ::PostMessage(pBApp->globals.g_OutHwnd, WM_USERINVALOUT, 0,0);
	if (pBApp->globals.LpdOpen)
	    ::PostMessage(pBApp->globals.g_LpdHwnd, WM_USERINVALLPD, 0,0);
  	if (pBApp->globals.Lpd2Open)
	  	::PostMessage(pBApp->globals.g_Lpd2Hwnd, WM_USERINVALLPD2, 0,0);
	if (pBApp->globals.KapOpen)
		::PostMessage(pBApp->globals.g_KapHwnd, WM_USERINVALKAP, 0,0);
	if (pBApp->globals.param_update_interval != 0) { 
		if (pBApp->globals.Kap2Open)
			::PostMessage(pBApp->globals.g_KapHwnd, WM_USERINVALKAP2, 0,0);
		if (pBApp->globals.KarOpen)
			::PostMessage(pBApp->globals.g_KarHwnd, WM_USERINVALKAR, 0,0);
	}
	if (pBApp->globals.TreOpen)
		::PostMessage(pBApp->globals.g_TreHwnd, WM_USERINVALTRE, 0,0);
	if (pBApp->globals.TopOpen)
		::PostMessage(pBApp->globals.g_TopHwnd, WM_USERINVALTOP, 0,0);
	if (pBApp->globals.THETAOpen)
		::SendMessage(pBApp->globals.g_THETAHwnd, WM_USERINVALTHETA, 0,0);
}

void CBAMBEView::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);	
}

void CBAMBEView::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);
}

void CBAMBEView::OnUpdateEditInitValues(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.RunAvail);	
}

void CBAMBEView::OnUpdateFileClose(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.RunAvail);	
}

void CBAMBEView::OnUpdateRunStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!pBApp->globals.RunAvail);		
}

void CBAMBEView::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	CBAMBEDoc* pDoc = GetDocument();

	pCmdUI->Enable(pDoc->IsModified());	
}

void CBAMBEView::OnRunPause() 
{
	pBApp->globals.IsPause = TRUE;
}

void CBAMBEView::OnUpdateRunPause(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!pBApp->globals.IsPause && !pBApp->globals.RunAvail);		
}

void CBAMBEView::OnRunResume() 
{
	pBApp->globals.IsPause = FALSE;
}

void CBAMBEView::OnUpdateRunResume(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.IsPause && !pBApp->globals.RunAvail);		
}

void CBAMBEView::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.RunAvail || pBApp->globals.IsPause);		
}

void CBAMBEView::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(pBApp->globals.RunAvail || pBApp->globals.IsPause);	
}

void CBAMBEView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CLogScrollView::OnPrint(pDC, pInfo);
}

void CBAMBEView::OnCloseAllWins()
{
	CCloseWins printmssg;
	int ans = printmssg.DoModal();

	if(ans == IDOK)
		pBApp->globals.CloseAllWins();
}

void CBAMBEView::OnUpdateCloseAllWins(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(pBApp->globals.CheckWindowStatus());
}