// BAMBEView.h : interface of the CBAMBEView class
//
/////////////////////////////////////////////////////////////////////////////

#include "LogScrollView.h"

class CBAMBEView : public CLogScrollView
{
protected: // create from serialization only
	CBAMBEView();
	DECLARE_DYNCREATE(CBAMBEView)

// Attributes
public:
	CBAMBEDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBAMBEView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL


// Implementation
public:
	virtual ~CBAMBEView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBAMBEView)
	afx_msg void OnRunRun();
	afx_msg void OnUpdateRunRun(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditInitValues(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnRunStop();
	afx_msg void OnUpdateRunStop(CCmdUI* pCmdUI);
	afx_msg void OnCloseAllWins();
	afx_msg void OnUpdateCloseAllWins(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnRunPause();
	afx_msg void OnUpdateRunPause(CCmdUI* pCmdUI);
	afx_msg void OnRunResume();
	afx_msg void OnUpdateRunResume(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg LRESULT OnUserStatus(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserChildRun(WPARAM wParam, LPARAM lParam);
	
	DECLARE_MESSAGE_MAP()

private:
	void PrintHeader(CDC* pDC);
	int m_npage;
};

UINT McmcThread(LPVOID);
void UpdateWindows();

#ifndef _DEBUG  // debug version in BAMBEView.cpp
inline CBAMBEDoc* CBAMBEView::GetDocument()
   { return (CBAMBEDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
