// DisplayFile.cpp : implementation file
//

#include <fstream.h>
#include "stdafx.h"
#include "bambe.h"
#include "DisplayFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAXLINE 1025

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CDisplayFile dialog


CDisplayFile::CDisplayFile(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayFile::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDisplayFile)
	m_output_file = _T("");
	//}}AFX_DATA_INIT
}


void CDisplayFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDisplayFile)
	DDX_Text(pDX, IDC_OUTPUT_FILE, m_output_file);
	DDV_MaxChars(pDX, m_output_file, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDisplayFile, CDialog)
	//{{AFX_MSG_MAP(CDisplayFile)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplayFile message handlers

void CDisplayFile::OnBrowse() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.lpd; *.out; *.par; *.top; *.tre",NULL,
		"Run Generated Output (*.lpd, *.out, *.par, *.top, *.tre)|*.lpd; *.out; *.par; *.top; *.tre|Estimate Parameter Files (*.est)|*.est|Final Tree Files (*.tre)|*.tre|Initial Output Files (*.out)|*.out|Log-likelihood Files (*.lpd)|*.lpd|Parameter Files (*.par)|*.par|Topology Files (*.top)|*.top|Summary Files (*.sum)|*.sum|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");

	if (getFile.DoModal() == IDOK)
	{
		m_output_file = getFile.GetPathName();
	}	
	UpdateData(FALSE);	
}

void CDisplayFile::OnOK() 
{
	UpdateData();

	BOOL data;
	CString ErrMsg;

	data = pBApp->globals.IsValidFile(m_output_file);
	if (!data) {
		AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_output_file);
		MessageBox (ErrMsg);
		return;
	}

	CDialog::OnOK();
}

void CDisplayFile::ReadFile()
{
	CString str;
	ifstream infile;

	char *file = new char[m_output_file.GetLength()+1];
	strcpy(file, m_output_file);
	
	infile.open(file);

	if (pBApp->globals.fileList != NULL)
		delete pBApp->globals.fileList;

	pBApp->globals.fileList = new CStringList;	// need to create it before creating the window

	BOOL ok = pBApp->pMain->SendMessage(WM_USERNEWFILE, 0,0);
	TRACE("Sending message WM_USERNEWFILE %s\n", ok ? "true" : "false");

	int i = 0;
	char buf[MAXLINE+1];

	str.Format("The information from this window can be found in %s", file);
	pBApp->globals.fileList->AddTail(str);
	str.Format(" ");
	pBApp->globals.fileList->AddTail(str);
	
	infile.getline(buf, MAXLINE);
	str.Format("%s", buf);
	pBApp->globals.fileList->AddTail(str);

	infile.getline(buf, MAXLINE);

	while(!infile.eof()) {
		str.Format("%s", buf);
		pBApp->globals.fileList->AddTail(str);

		infile.getline(buf, MAXLINE);
		i++;
		if(i % 10 == 0) {
			::PostMessage(pBApp->globals.g_FILEHwnd, WM_USERINVALFILE, 0,0);
		}
	}

	::PostMessage(pBApp->globals.g_FILEHwnd, WM_USERINVALFILE, 0,0);

	delete [] file;
}

