// DisplayParam.cpp : implementation file
//

#include "stdafx.h"
#include "bambe.h"
#include "DisplayParam.h"
#include "parfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// DisplayParam dialog

static DWORD aDPHelpIDs[] = 
{
	IDC_PARAM_FILE, HIDC_PARAM_FILE,
	IDC_STATIC_PAR_FILE, HIDC_PARAM_FILE,
	IDC_TREE_FILE, HIDC_TREE_FILE,
	IDC_STATIC_TREE_FILE, HIDC_TREE_FILE,
	IDC_BROWSE, HIDD_BROWSE,
	IDC_BROWSE2, HIDD_BROWSE,
	IDC_OUT_KAP, HIDC_OUT_WINDOWS,
	IDC_OUT_KAR, HIDC_OUT_WINDOWS,
	IDC_OUT_LPD1, HIDC_OUT_WINDOWS,
	IDC_OUT_LPD2, HIDC_OUT_WINDOWS,
	IDC_OUT_TAR, HIDC_OUT_WINDOWS,
	IDC_OUT_TOP, HIDC_OUT_WINDOWS,
	IDC_OUT_THETA, HIDC_OUT_WINDOWS,
	IDC_DISPLAY_INT, HIDC_DISPLAY_INT,
	IDC_RADIO2, HIDC_DISPLAY_INT,
	IDC_CK_FIRST, HIDC_CK_FIRST,
	IDC_CK_LAST, HIDC_CK_LAST,
	IDC_BEGIN_CYCLE, HIDC_BEGIN_CYCLE,
	IDC_STATIC_START_CY,  HIDC_BEGIN_CYCLE,
	IDC_END_CYCLE, HIDC_END_CYCLE,
	IDC_STATIC_END_CY, HIDC_END_CYCLE,
	IDOK, HIDD_OK,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	0, 0
};


DisplayParam::DisplayParam(CWnd* pParent /*=NULL*/)
	: CDialog(DisplayParam::IDD, pParent)
{
	//{{AFX_DATA_INIT(DisplayParam)
	m_begin_cycle = 0;
	m_end_cycle = 0;
	m_ck_KAP = TRUE;
	m_ck_KAR = TRUE;
	m_ck_LPD1 = TRUE;
	m_ck_LPD2 = TRUE;
	m_ck_TAR = TRUE;
	m_ck_TOP = TRUE;
	m_ck_THETA = TRUE;
	m_param_file = _T("");
	m_display_int = 0;
	m_ck_first = FALSE;
	m_ck_last = FALSE;
	m_tree_file = _T("");
	m_ck_max_cycle = FALSE;
	m_max_cycle = 0;
	m_tree_format = 0;
	//}}AFX_DATA_INIT
}

void DisplayParam::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DisplayParam)
	DDX_Text(pDX, IDC_BEGIN_CYCLE, m_begin_cycle);
	DDX_Text(pDX, IDC_END_CYCLE, m_end_cycle);
	DDX_Check(pDX, IDC_OUT_KAP, m_ck_KAP);
	DDX_Check(pDX, IDC_OUT_KAR, m_ck_KAR);
	DDX_Check(pDX, IDC_OUT_LPD1, m_ck_LPD1);
	DDX_Check(pDX, IDC_OUT_LPD2, m_ck_LPD2);
	DDX_Check(pDX, IDC_OUT_TAR, m_ck_TAR);
	DDX_Check(pDX, IDC_OUT_TOP, m_ck_TOP);
	DDX_Check(pDX, IDC_OUT_THETA, m_ck_THETA);
	DDX_Text(pDX, IDC_PARAM_FILE, m_param_file);
	DDV_MaxChars(pDX, m_param_file, 80);
	DDX_Radio(pDX, IDC_DISPLAY_INT, m_display_int);
	DDX_Check(pDX, IDC_CK_FIRST, m_ck_first);
	DDX_Check(pDX, IDC_CK_LAST, m_ck_last);
	DDX_Text(pDX, IDC_TREE_FILE, m_tree_file);
	DDV_MaxChars(pDX, m_tree_file, 80);
	DDX_Check(pDX, IDC_CK_MAX_CYCLES, m_ck_max_cycle);
	DDX_Text(pDX, IDC_MAX_CYCLES, m_max_cycle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DisplayParam, CDialog)
	//{{AFX_MSG_MAP(DisplayParam)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_DISPLAY_INT, OnDisplayInt)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_CK_LAST, OnCkLast)
	ON_BN_CLICKED(IDC_CK_FIRST, OnCkFirst)
	ON_BN_CLICKED(IDC_OUT_TOP, OnOutTop)
	ON_BN_CLICKED(IDC_OUT_KAP, OnOutputPar)
	ON_WM_CONTEXTMENU()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_OUT_KAR, OnOutputPar)
	ON_BN_CLICKED(IDC_OUT_LPD1, OnOutputPar)
	ON_BN_CLICKED(IDC_OUT_LPD2, OnOutputPar)
	ON_BN_CLICKED(IDC_OUT_TAR, OnOutputPar)
	ON_BN_CLICKED(IDC_OUT_THETA, OnOutputPar)
	ON_BN_CLICKED(IDC_CK_MAX_CYCLES, OnCkMaxCycle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DisplayParam message handlers
void DisplayParam::OnBrowse() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.par",NULL,"Parameter Files (*.par)|*.par|All Files (*.*)|*.*||");

	if (getFile.DoModal() == IDOK)
	{
		m_param_file = getFile.GetPathName();
	}	
	m_ck_max_cycle = FALSE;
	m_max_cycle = 0;
	UpdateData(FALSE);	
}

BOOL DisplayParam::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ChangeStatus(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DisplayParam::ChangeStatus(BOOL val)
{
	CWnd *pBox;
	pBox = GetDlgItem(IDC_BEGIN_CYCLE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_END_CYCLE);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_STATIC_START_CY);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_STATIC_END_CY);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_CK_FIRST);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_CK_LAST);
	if (pBox)
		pBox->EnableWindow(val);
}

void DisplayParam::OnDisplayInt() 
{
	ChangeStatus(FALSE);
}

void DisplayParam::OnRadio2() 
{
	ChangeStatus(TRUE);
}

void DisplayParam::OnOK() 
{
	UpdateData();

	BOOL data;
	int flag = 1;
	CString ErrMsg;

	if(m_ck_KAP || m_ck_KAR || m_ck_LPD1 || 
		m_ck_LPD2 || m_ck_TAR || m_ck_THETA) {
		data = pBApp->globals.IsValidFile(m_param_file);
		if (!data) {
			flag = 0;
			AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_param_file);
			MessageBox (ErrMsg);
		}
	}

	if(m_ck_TOP) {
		data = pBApp->globals.IsValidFile(m_tree_file);
		if(!data) {
			flag = 0;
			AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_tree_file);
			MessageBox (ErrMsg);
		}
	}

	if(m_display_int) {
		if((!m_ck_last && m_end_cycle <= m_begin_cycle) ||
			(!m_ck_first && m_begin_cycle >= m_end_cycle) ||
			(!m_ck_last && m_end_cycle < 0) ||
			(!m_ck_first && m_begin_cycle < 0)) {
			flag = 0;
			ErrMsg.Format("ERROR: \r\n\nThe beginning and ending cycles do not create a valid range.\nPlease check these values.");
			MessageBox (ErrMsg);
		}
	}

	if(flag) {
		//ErrMsg.Format("The size of the data files specified affects the amount of time needed to redisplay the data.\n\n\t\t\t   Please be patient. ");
		//MessageBox(ErrMsg);
		CDialog::OnOK();
	}
}

void DisplayParam::OnBrowse2() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.tre",NULL,"Final Tree File (*.tre)|*.tre|All Files (*.*) |*.*||");

	if (getFile.DoModal() == IDOK)
	{
		m_tree_file = getFile.GetPathName();
	}	
	UpdateData(FALSE);	
	
}

void DisplayParam::OnCkLast() 
{
	UpdateData();
	
	BOOL val = m_ck_last;

	CWnd *pBox;

	pBox = GetDlgItem(IDC_END_CYCLE);
	if (pBox)
		pBox->EnableWindow(!val);
	pBox = GetDlgItem(IDC_STATIC_END_CY);
	if (pBox)
		pBox->EnableWindow(!val);
}

void DisplayParam::OnCkFirst() 
{
	UpdateData();
	
	BOOL val = m_ck_first;

	CWnd *pBox;
	pBox = GetDlgItem(IDC_BEGIN_CYCLE);
	if (pBox)
		pBox->EnableWindow(!val);
	pBox = GetDlgItem(IDC_STATIC_START_CY);
	if (pBox)
		pBox->EnableWindow(!val);
}

void DisplayParam::OnOutTop() 
{
	UpdateData();
	
	BOOL val = m_ck_TOP;

	CWnd *pBox;
	pBox = GetDlgItem(IDC_BROWSE2);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_STATIC_TREE_FILE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_TREE_FILE);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_STATIC_FINAL_TREE);
	if (pBox)
		pBox->EnableWindow(val);
}

void DisplayParam::OnOutputPar() 
{
	UpdateData();
	
	BOOL val = (!m_ck_KAP && !m_ck_KAR && !m_ck_LPD1 && !m_ck_LPD2 &&
		!m_ck_TAR && !m_ck_THETA) ? FALSE : TRUE;

	CWnd *pBox;
	pBox = GetDlgItem(IDC_BROWSE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_STATIC_PAR_FILE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_PARAM_FILE);
	if (pBox)
		pBox->EnableWindow(val);
}

void DisplayParam::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aDPHelpIDs);
}

BOOL DisplayParam::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aDPHelpIDs);
	}
	return TRUE;	
}

void DisplayParam::OnCkMaxCycle() 
{
	UpdateData();
	
	if (m_ck_max_cycle == TRUE) {
		HCURSOR newCursor, oldCursor;
  
		// Load the predefined Windows "hourglass" cursor.
		newCursor = AfxGetApp()->LoadStandardCursor(IDC_WAIT);	
		oldCursor = SetCursor(newCursor);		// set the new cursor
		pBApp->UpdateStatusBar(1);

		CString ErrMsg;

		BOOL data = pBApp->globals.IsValidFile(m_param_file);
		if (!data) {
			AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_param_file);
			MessageBox (ErrMsg);
			m_ck_max_cycle = FALSE;
			UpdateData(FALSE);
		}
		else {
		    char *c = new char[m_param_file.GetLength()+1];
			strcpy(c, m_param_file);

			ParamFile temp(c, " ");
			m_max_cycle = temp.GetMaxCycle();
			UpdateData(FALSE);

			delete [] c;
		}

		SetCursor(oldCursor);	// reset the old cursor
		pBApp->UpdateStatusBar(0);
	}
}
