// EstParams.cpp : implementation file
//

#include "stdafx.h"
#include "bambe.h"
#include "EstParams.h"
#include "parfile.h"
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CEstParams dialog

static DWORD aEstParamsHelpIDs[] = 
{
	IDC_PARAM_FILE, HIDC_PARAM_FILE,
	IDC_STATIC_PAR_FILE, HIDC_PARAM_FILE,
	IDC_OUTPUT_FILE, HIDC_OUTPUT_FILE,
	IDC_STATIC_OUT_FILE, HIDC_OUTPUT_FILE,
	IDC_BROWSE, HIDD_BROWSE,
	IDC_BROWSE2, HIDD_BROWSE,
	IDOK, HIDD_OK,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	0, 0
};


CEstParams::CEstParams(CWnd* pParent /*=NULL*/)
	: CDialog(CEstParams::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEstParams)
	m_ck_output = FALSE;
	m_output_file = _T("");
	m_param_file = _T("");
	//}}AFX_DATA_INIT
}


void CEstParams::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEstParams)
	DDX_Check(pDX, IDC_CK_OUT_FILE, m_ck_output);
	DDX_Text(pDX, IDC_OUTPUT_FILE, m_output_file);
	DDV_MaxChars(pDX, m_output_file, 100);
	DDX_Text(pDX, IDC_PARAM_FILE, m_param_file);
	DDV_MaxChars(pDX, m_param_file, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEstParams, CDialog)
	//{{AFX_MSG_MAP(CEstParams)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_CK_OUT_FILE, OnCkOutFile)
	ON_WM_HELPINFO()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEstParams message handlers

void CEstParams::OnOK() 
{
	UpdateData();

	BOOL data;
	int flag = 1;
	CString ErrMsg;

	data = pBApp->globals.IsValidFile(m_param_file);

	if (!data) {
		flag = 0;
		AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_param_file);
		MessageBox (ErrMsg);
	}

	if(flag)
		CDialog::OnOK();
}

void CEstParams::OnBrowse() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.par",NULL,"Parameter Files (*.par)|*.par|All Files (*.*)|*.*||");

	if (getFile.DoModal() == IDOK) {
		m_param_file = getFile.GetPathName();
		if(m_output_file.IsEmpty()) {
			char *c = new char[m_param_file.GetLength() + 1];
			strcpy(c, m_param_file);
			char *token = strchr(c, '.');
			strcpy(token, ".est");
			m_output_file.Format("%s", c);
			delete [] c;
		}
	}	

	UpdateData(FALSE);	
}

void CEstParams::OnBrowse2() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.est",NULL,"Estimate Parameter Files (*.est)|*.est|All Files (*.*)|*.*||");

	if (getFile.DoModal() == IDOK) {
		m_param_file = getFile.GetPathName();
	}	
	UpdateData(FALSE);	
}

BOOL CEstParams::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ChangeStatus(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEstParams::OnCkOutFile() 
{
	UpdateData();
	ChangeStatus(m_ck_output);
}

void CEstParams::ChangeStatus(BOOL val)
{
	CWnd *pBox;
	pBox = GetDlgItem(IDC_STATIC_OUT_FILE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_OUTPUT_FILE);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_BROWSE2);
	if (pBox)
		pBox->EnableWindow(val);
}

void CEstParams::RunEstimations()
{
	char *file = new char[m_param_file.GetLength()+1];
	strcpy(file, m_param_file);

	char c[5];
	strcpy(c, "temp");
	ParamFile param(file, c);
	delete [] file;

	file = new char[m_output_file.GetLength() +1];
	strcpy(file, m_output_file);

	param.CalcEstimations(file, m_ck_output);
	delete [] file;
}

BOOL CEstParams::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aEstParamsHelpIDs);
	}
	return TRUE;	
}

void CEstParams::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aEstParamsHelpIDs);

}
