// GenDoc.cpp : implementation of the CGenericDoc class
//

#include "stdafx.h"
#include "BAMBE.h"

#include "GenDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CBAMBEApp* pBApp;

/////////////////////////////////////////////////////////////////////////////
// CGenericDoc

IMPLEMENT_DYNCREATE(CGenericDoc, CDocument)

BEGIN_MESSAGE_MAP(CGenericDoc, CDocument)
	//{{AFX_MSG_MAP(CGenericDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenericDoc construction/destruction

CGenericDoc::CGenericDoc()
{
}

CGenericDoc::CGenericDoc(int type)
{
	WindowType = type;

	switch (WindowType) {
	case 0: pBApp->globals.KapOpen = 1; break;		// Tree Acceptance Rate
	case 1: pBApp->globals.Kap2Open = 1; break;		// Kappa Update Values
	case 2: pBApp->globals.LpdOpen = 1; break;		// Log Likelihood
	case 3: pBApp->globals.Lpd2Open = 1; break;		// Log Likelihood - Main
	case 4: pBApp->globals.TreOpen = 1; break;		// Final Tree Data
	case 5: pBApp->globals.KarOpen = 1; break;		// Parameter Acceptance Rate
	case 6: pBApp->globals.THETAOpen = 1; break;	// Theta Update Values
	case 7: pBApp->globals.TTPOpen = 1; break;		// TTP Update Values
	case 8: pBApp->globals.GAMOpen = 1; break;		// Gamma Update Values
	case 9: pBApp->globals.OutOpen = 1; break;		// Initial Output
	case 10: pBApp->globals.TopOpen = 1; break;		// Tree Topology
	case 11: pBApp->globals.SUMOpen = 1; break;		// Summarize Tree Topologies
	case 12: pBApp->globals.ESTOpen = 1; break;		// Estimate Parameters
	case 13: pBApp->globals.FILEOpen = 1; break;	// Display Output File
	}
}

CGenericDoc::~CGenericDoc()
{
}

BOOL CGenericDoc::OnNewDocument()
{
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CGenericDoc serialization

void CGenericDoc::Serialize(CArchive& ar)
{
}

/////////////////////////////////////////////////////////////////////////////
// CGenericDoc diagnostics

#ifdef _DEBUG
void CGenericDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGenericDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGenericDoc commands

void CGenericDoc::DeleteContents() 
{
	CDocument::DeleteContents();
}

void CGenericDoc::OnCloseDocument() 
{	
	switch (WindowType) {
	case 0: pBApp->globals.KapOpen = 0; break;		// Tree Acceptance Rate
	case 1: pBApp->globals.Kap2Open = 0; break;		// Kappa Update Values
	case 2: pBApp->globals.LpdOpen = 0; break;		// Log Likelihood
	case 3: pBApp->globals.Lpd2Open = 0; break;		// Log Likelihood - Main
	case 4: pBApp->globals.TreOpen = 0; break;		// Final Tree Data
	case 5: pBApp->globals.KarOpen = 0; break;		// Parameter Acceptance Rate
	case 6: pBApp->globals.THETAOpen = 0; break;	// Theta Update Values
	case 7: pBApp->globals.TTPOpen = 0; break;		// TTP Update Values
	case 8: pBApp->globals.GAMOpen = 0; break;		// Gamma Update Values
	case 9: pBApp->globals.OutOpen = 0; break;		// Initial Output
	case 10: pBApp->globals.TopOpen = 0; break;		// Tree Topology
	case 11: pBApp->globals.SUMOpen = 0; break;		// Summarize Tree Topologies
	case 12: pBApp->globals.ESTOpen = 0; break;		// Estimate Parameters
	case 13: pBApp->globals.FILEOpen = 0; break;	// Display Output File
	}
	CDocument::OnCloseDocument();
}

