// KAP2View.h : interface of the CKAP2View class
//
/////////////////////////////////////////////////////////////////////////////

#include "gendoc.h"

class CKAP2View : public CScrollView
{
protected: 
	int curCyCt, kapArCt;

	CSize	m_DocSize;		
	CFont*	m_pFont;		
	void ComputeViewMetrics();
	int ComputeVisibleLines(CDC* pDC, int& nFirst, int& nLast);
	void Perfmeter(CDC* pDC, int nFirst, int nLast, double xscale, int header);

	CKAP2View();
	DECLARE_DYNCREATE(CKAP2View)

// Attributes
public:
	CGenericDoc* GetDocument();
	CSize	GetDocSize() const { return m_DocSize; }
	CFont*	GetFont();


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKAP2View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

public:
	void OnUpdate();

// Implementation
public:
	void PrintHorzScale(CDC* pDC, int nFirst, int nLast, double xscale, int header);
	void PrintVertScale(CDC* pDC, int header);
	virtual ~CKAP2View();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CKAP2View)
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnRunStop();
	afx_msg void OnUpdateRunStop(CCmdUI* pCmdUI);
	afx_msg void OnRunPause();
	afx_msg void OnUpdateRunPause(CCmdUI* pCmdUI);
	afx_msg void OnRunResume();
	afx_msg void OnUpdateRunResume(CCmdUI* pCmdUI);
	afx_msg void OnRunRun();
	afx_msg void OnUpdateRunRun(CCmdUI* pCmdUI);
	afx_msg void OnCloseAllWins();
	afx_msg void OnUpdateCloseAllWins(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg LRESULT OnUserInvalKap2(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserCloseKap2(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
private:
	int m_nMax;
	void PrintHeader(CDC* pDC);
	int m_npage;
	BOOL IsDrawing;
};

#ifndef _DEBUG  // debug version in KAP2View.cpp
inline CGenericDoc* CKAP2View::GetDocument()
   { return (CGenericDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
