// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "BAMBE.h"
#include "MainFrm.h"

#include "GenDoc.h"

#include "Splash.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBAMBEApp* pBApp;
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_ACTIVATEAPP()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USERNEWOUT, OnUserNewOUT)
	ON_MESSAGE(WM_USERNEWTOP, OnUserNewTOP)
	ON_MESSAGE(WM_USERNEWKAP, OnUserNewKAP)
	ON_MESSAGE(WM_USERNEWLPD, OnUserNewLPD)
	ON_MESSAGE(WM_USERNEWLPD2, OnUserNewLPD2)
	ON_MESSAGE(WM_USERNEWTRE, OnUserNewTRE)
	ON_MESSAGE(WM_USERNEWKAP2, OnUserNewKAP2)
	ON_MESSAGE(WM_USERNEWKAR, OnUserNewKAR)
	ON_MESSAGE(WM_USERNEWSUM, OnUserNewSUM)
	ON_MESSAGE(WM_USERNEWEST, OnUserNewEST)
	ON_MESSAGE(WM_USERNEWTHETA, OnUserNewTHE)
	ON_MESSAGE(WM_USERNEWFILE, OnUserNewFILE)
	ON_MESSAGE(WM_USERNEWTTP, OnUserNewTTP)
	ON_MESSAGE(WM_USERNEWGAM, OnUserNewGAM)

	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::ShowSplashScreen(this);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
/*	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;
*/
	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

LRESULT CMainFrame::OnUserNewOUT(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(9);
	CString Name;
	Name.Format("Initial Output");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateO = ((CBAMBEApp*) AfxGetApp())->m_pTemplateOut;
	ASSERT_VALID(pTemplateO);
	
	CFrameWnd* pFrame = pTemplateO->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateO->InitialUpdateFrame(pFrame, pDocument);
	pFrame->ShowWindow(SW_SHOWMINNOACTIVE);
	return 1;
}

LRESULT CMainFrame::OnUserNewTOP(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(10);
	CString Name;
	Name.Format("Tree Topology");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateT = ((CBAMBEApp*) AfxGetApp())->m_pTemplateTop;
	ASSERT_VALID(pTemplateT);
	
	CFrameWnd* pFrame = pTemplateT->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateT->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewKAP(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(0);
	CString Name;
	Name.Format("Tree Acceptance Rate");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateK = ((CBAMBEApp*) AfxGetApp())->m_pTemplateKap;
	ASSERT_VALID(pTemplateK);
	
	CFrameWnd* pFrame = pTemplateK->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateK->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewKAP2(WPARAM wParam, LPARAM lParam)
{	
	CDocument* pDocument = new CGenericDoc(1);
	CString Name;
	Name.Format("Kappa Update Values");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateK2 = ((CBAMBEApp*) AfxGetApp())->m_pTemplateKap2;
	ASSERT_VALID(pTemplateK2);
	
	CFrameWnd* pFrame = pTemplateK2->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateK2->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewLPD(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(2);
	CString Name;
	Name.Format("Log Likelihood");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateL = ((CBAMBEApp*) AfxGetApp())->m_pTemplateLpd;
	ASSERT_VALID(pTemplateL);
	
	CFrameWnd* pFrame = pTemplateL->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateL->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewLPD2(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(3);
	CString name;
	name.Format("Log Likelihood - Main");
	pDocument->SetTitle(name);
	CDocTemplate* pTemplateL = ((CBAMBEApp*) AfxGetApp())->m_pTemplateLpd2;
	ASSERT_VALID(pTemplateL);
	
	CFrameWnd* pFrame = pTemplateL->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateL->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewTRE(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(4);
	CString Name;
	Name.Format("Final Tree Data");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateT = ((CBAMBEApp*) AfxGetApp())->m_pTemplateTre;
	ASSERT_VALID(pTemplateT);
	
	CFrameWnd* pFrame = pTemplateT->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateT->InitialUpdateFrame(pFrame, pDocument);
	pFrame->ShowWindow(SW_SHOWMINNOACTIVE);
	return 1;
}

LRESULT CMainFrame::OnUserNewKAR(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(5);
	CString Name;
	Name.Format("Parameter Acceptance Rate");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateK = ((CBAMBEApp*) AfxGetApp())->m_pTemplateKar;
	ASSERT_VALID(pTemplateK);
	
	CFrameWnd* pFrame = pTemplateK->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateK->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewSUM(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(11);
	CString Name;
	Name.Format("Summarize Tree Topologies");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateS = ((CBAMBEApp*) AfxGetApp())->m_pTemplateSum;
	ASSERT_VALID(pTemplateS);
	
	CFrameWnd* pFrame = pTemplateS->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateS->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewEST(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(12);
	CString Name;
	Name.Format("Estimate Parameters");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateE = ((CBAMBEApp*) AfxGetApp())->m_pTemplateEst;
	ASSERT_VALID(pTemplateE);
	
	CFrameWnd* pFrame = pTemplateE->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateE->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewTHE(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(6);
	CString Name;
	Name.Format("Theta Update Values");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateT = ((CBAMBEApp*) AfxGetApp())->m_pTemplateTheta;
	ASSERT_VALID(pTemplateT);
	
	CFrameWnd* pFrame = pTemplateT->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateT->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewFILE(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(13);
	CString Name;
	Name.Format("Ouput File");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateF = ((CBAMBEApp*) AfxGetApp())->m_pTemplateFile;
	ASSERT_VALID(pTemplateF);
	
	CFrameWnd* pFrame = pTemplateF->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateF->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewTTP(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(7);
	CString Name;
	Name.Format("TTP Update Values");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateT = ((CBAMBEApp*) AfxGetApp())->m_pTemplateTtp;
	ASSERT_VALID(pTemplateT);
	
	CFrameWnd* pFrame = pTemplateT->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateT->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

LRESULT CMainFrame::OnUserNewGAM(WPARAM wParam, LPARAM lParam)
{
	CDocument* pDocument = new CGenericDoc(8);
	CString Name;
	Name.Format("Gamma Update Values");
	pDocument->SetTitle(Name);
	CDocTemplate* pTemplateG = ((CBAMBEApp*) AfxGetApp())->m_pTemplateGam;
	ASSERT_VALID(pTemplateG);
	
	CFrameWnd* pFrame = pTemplateG->CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return 0;
	}
	pTemplateG->InitialUpdateFrame(pFrame, pDocument);
	return 1;
}

void CMainFrame::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CMDIFrameWnd::OnActivateApp(bActive, hTask);
	
	if(bActive) {
		UpdateWindow();
		pBApp->globals.UpdateAllWins();
	}
}

LRESULT CMainFrame::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(wParam != SC_SCREENSAVE)
		return CMDIFrameWnd::DefWindowProc(message, wParam, lParam);
	else return 0;
}
