// Output.cpp

#include "stdafx.h"
#include "BAMBE.h"

#include "OUTDoc.h"
#include "OUTView.h"
#include "MainFrm.h"

extern CBAMBEApp* pBApp;

extern CDocTemplate* pTemplate;
extern CWnd* pMainWnd;

CFrameWnd* CreateNewFrame(CDocument*, CFrameWnd*);
/*
BOOL LoadFrame(UINT, DWORD, CWnd*, CCreateContext*, CMDIChildWnd*);

BOOL LoadFrame(UINT nIDResource, DWORD dwDefaultStyle,
		CWnd* pParentWnd, CCreateContext* pContext, CMDIChildWnd* pFrame)
{
	// only do this once
//	ASSERT_VALID_IDR(nIDResource);
	ASSERT(pFrame->m_nIDHelp == 0 || pFrame->m_nIDHelp == nIDResource);
	ASSERT(pFrame->m_hMenuShared == NULL);      // only do once

	pFrame->m_nIDHelp = nIDResource;    // ID for help context (+HID_BASE_RESOURCE)

	// parent must be MDI Frame (or NULL for default)
	ASSERT(pParentWnd == NULL || pParentWnd->IsKindOf(RUNTIME_CLASS(CMDIFrameWnd)));
	// will be a child of MDIClient
	ASSERT(!(dwDefaultStyle & WS_POPUP));
	dwDefaultStyle |= WS_CHILD;

	// if available - get MDI child menus from doc template
	ASSERT(pFrame->m_hMenuShared == NULL);      // only do once
	CMultiDocTemplate* pTemplate;
	if (pContext != NULL &&
		(pTemplate = (CMultiDocTemplate*)pContext->m_pNewDocTemplate) != NULL)
	{
		ASSERT_KINDOF(CMultiDocTemplate, pTemplate);
		// get shared menu from doc template
		pFrame->m_hMenuShared = pTemplate->m_hMenuShared;
		pFrame->m_hAccelTable = pTemplate->m_hAccelTable;
	}
	else {
		TRACE0("Warning: no shared menu/acceltable for MDI Child window.\n");
			// if this happens, programmer must load these manually
	}

	CString strFullString, strTitle;
	if (strFullString.LoadString(nIDResource))
		AfxExtractSubString(strTitle, strFullString, 0);    // first sub-string

//	ASSERT(m_hWnd == NULL);
	if (!pFrame->Create(pFrame->GetIconWndClass(dwDefaultStyle, nIDResource),
	  strTitle, dwDefaultStyle, rectDefault,
	  (CMDIFrameWnd*)pMainWnd, pContext)) {
		return FALSE;   // will self destruct on failure normally
	}

	// it worked !
	return TRUE;
}*/

CFrameWnd* CreateNewFrame(CDocument* pDoc, CFrameWnd* pOther)
{
	if (pDoc != NULL)
		ASSERT_VALID(pDoc);
	// create a frame wired to the specified document

	ASSERT(pTemplate->m_nIDResource != 0); // must have a resource ID to load from
	CCreateContext context;
	context.m_pCurrentFrame = pOther;
	context.m_pCurrentDoc = pDoc;
	context.m_pNewViewClass = pTemplate->m_pViewClass;
	context.m_pNewDocTemplate = pTemplate;

	if (pTemplate->m_pFrameClass == NULL)
	{
		TRACE0("Error: you must override CDocTemplate::CreateNewFrame.\n");
		ASSERT(FALSE);
		return NULL;
	}
	CFrameWnd* pFrame = (CFrameWnd*)(pTemplate->m_pFrameClass)->CreateObject();
	if (pFrame == NULL)
	{
		TRACE1("Warning: Dynamic create of frame %hs failed.\n",
			pTemplate->m_pFrameClass->m_lpszClassName);
		return NULL;
	}
	ASSERT_KINDOF(CFrameWnd, pFrame);

	if (context.m_pNewViewClass == NULL)
		TRACE0("Warning: creating frame with no default view.\n");

	// create new from resource
	if (!pFrame->LoadFrame(pTemplate->m_nIDResource,
			WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,   // default frame styles
			pMainWnd, &context))
	{
		TRACE0("Warning: couldn't create a frame.\n");
		// frame will be deleted in PostNcDestroy cleanup
		return NULL;
	}

	// it worked !
	return pFrame;
}

void CreateOUTWindow()
{
	CDocument* pDocument= new COUTDoc;
	ASSERT_VALID(pTemplate);
	
	CFrameWnd* pFrame = CreateNewFrame(pDocument, NULL);
	if (pFrame == NULL) {
		TRACE("Warning: failed to create new frame\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return;
	}
	pTemplate->InitialUpdateFrame(pFrame, pDocument);

	//return pDocument;
}

