// ParFile.h - To parse the parameter file

#include <fstream.h>

#define MAXLINE 1025
#define MAXCOL 100

class param {
public:
	double *kap, *theta, *gamma, *ttp;
	double *pia, *pig, *pic, *pit;
	param(int n) {kap = new double[n+1]; theta = new double[n+1];
			gamma = new double[n+1]; ttp = new double[n+1];
			pia = new double[n+1]; pic = new double[n+1]; 
			pig = new double[n+1]; pit = new double[n+1]; }
	~param() { delete [] kap; delete [] theta; delete [] gamma; delete [] ttp;
			delete [] pic; delete [] pia; delete [] pig; delete [] pit;}
};

class ParamFile {
public:
	ParamFile(char*, char*);
	~ParamFile();
	int GetMaxCycle();
	int GetValues(int, int, int&);
	int Parse(int, int);
	void CalcEstimations(char*, int);
	int tot_lines;

private:
	char FileName[81], TreeFile[81];
	double  newmean[MAXCOL], oldmean[MAXCOL], sumsq[MAXCOL];

	double *logs, *TAR, *PAR, *Radius;
	param *cat[10];
	CStringList *m_EstList;
	int qInd[9];

	int FindMeans(int&);
	int ConvertToInt(char*);
	void Storage(ifstream&, int&);
	void SkipInfo(ifstream&);
	void InitializeArrays();
	void DeleteArrays();
	void SortArrays();
	void DetermineQuantiles();
	void PrintSection(double*, int, CString);
	void PrintToFile(char*);
	void PrintToScreen(int);
};
