#include "globalVars.h"
#include "stdafx.h"

GlobalVars::GlobalVars()
{
	data_file[0] = tree_file[0] = file_root[0] = '\0';
	RunAvail = TRUE;
	DocIsOpen = FALSE;
	initialized = 0;
	EstList = NULL;
	fileList = NULL;
	sumList = NULL;

	OutOpen = TopOpen = KapOpen = Kap2Open 
		= LpdOpen = Lpd2Open = TreOpen = KarOpen 
		= FILEOpen = THETAOpen = TTPOpen = GAMOpen 
		= ESTOpen = SUMOpen = 0;

	g_OutHwnd = g_TopHwnd = g_KapHwnd = g_Kap2Hwnd = g_THETAHwnd =
	g_LpdHwnd = g_Lpd2Hwnd = g_TreHwnd = g_KarHwnd = g_SUMHwnd = 
	g_BViewHwnd = g_ESTHwnd = g_FILEHwnd = g_TTPHwnd = g_GAMHwnd = NULL;
}

GlobalVars::~GlobalVars()
{
	if (EstList != NULL)
		delete EstList;
	if (fileList != NULL)
		delete fileList;
	if (sumList != NULL)
		delete sumList;
}

int GlobalVars::CheckWindowStatus()
{
  return (OutOpen || TopOpen || KapOpen || Kap2Open 
		|| LpdOpen || Lpd2Open || TreOpen || KarOpen 
		|| FILEOpen || THETAOpen || TTPOpen || GAMOpen 
		|| ESTOpen || SUMOpen);
}

void GlobalVars::CloseAllWins()
{
	if (OutOpen)
		::PostMessage(g_OutHwnd, WM_USERCLOSEOUT, 0,0);
	if (TopOpen)
		::PostMessage(g_TopHwnd, WM_USERCLOSETOP, 0,0);
	if (KapOpen)
		::PostMessage(g_KapHwnd, WM_USERCLOSEKAP, 0,0);
	if (Kap2Open)
		::PostMessage(g_Kap2Hwnd, WM_USERCLOSEKAP2, 0,0);
	if (LpdOpen)
		::PostMessage(g_LpdHwnd, WM_USERCLOSELPD, 0,0);
	if (Lpd2Open)
		::PostMessage(g_Lpd2Hwnd, WM_USERCLOSELPD2, 0,0);
	if (TreOpen) 
		::PostMessage(g_TreHwnd, WM_USERCLOSETRE, 0,0);
	if (KarOpen)
		::PostMessage(g_KarHwnd, WM_USERCLOSEKAR, 0,0);
	if (SUMOpen)
		::PostMessage(g_SUMHwnd, WM_USERCLOSESUM, 0,0);
	if (ESTOpen)
		::PostMessage(g_ESTHwnd, WM_USERCLOSEEST, 0,0);
	if (THETAOpen)
		::SendMessage(g_THETAHwnd, WM_USERCLOSETHETA, 0,0);
	if (FILEOpen)
		::PostMessage(g_SUMHwnd, WM_USERCLOSEFILE, 0,0);
	if (GAMOpen)
		::PostMessage(g_GAMHwnd, WM_USERCLOSEGAM, 0,0);
	if (TTPOpen)
		::PostMessage(g_TTPHwnd, WM_USERCLOSETTP, 0,0);

	OutOpen = TopOpen = KapOpen = Kap2Open 
		= LpdOpen = Lpd2Open = TreOpen = KarOpen 
		= FILEOpen = THETAOpen = TTPOpen = GAMOpen 
		= ESTOpen = SUMOpen = 0;
}

void GlobalVars::UpdateAllWins()
{
  	if (OutOpen)
	    ::PostMessage(g_OutHwnd, WM_USERINVALOUT, 0,0);
  	if (Lpd2Open)
	  	::PostMessage(g_Lpd2Hwnd, WM_USERINVALLPD2, 0,0);
	if (KapOpen)
		::PostMessage(g_KapHwnd, WM_USERINVALKAP, 0,0);
	if (LpdOpen) 
		::PostMessage(g_LpdHwnd, WM_USERINVALLPD, 0,0);
	if (Kap2Open)
		::PostMessage(g_KapHwnd, WM_USERINVALKAP2, 0,0);
	if (THETAOpen)
		::PostMessage(g_THETAHwnd, WM_USERINVALTHETA, 0,0);
	if (KarOpen)
		::PostMessage(g_KarHwnd, WM_USERINVALKAR, 0,0);
	if (TreOpen)	
		::PostMessage(g_TreHwnd, WM_USERINVALTRE, 0,0);
	if (TopOpen)
		::PostMessage(g_TopHwnd, WM_USERINVALTOP, 0,0);
	if (TTPOpen)	
		::PostMessage(g_TTPHwnd, WM_USERINVALTTP, 0,0);
	if (GAMOpen)
		::PostMessage(g_GAMHwnd, WM_USERINVALGAM, 0,0);
}

void GlobalVars::EnableMaximize()
{
	LONG style;

	if(LpdOpen) {
		style = GetWindowLong(g_LpdHwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_LpdHwnd, GWL_STYLE, style);
	}
	if(Lpd2Open) {
		style = GetWindowLong(g_Lpd2Hwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_Lpd2Hwnd, GWL_STYLE, style);
	}
	if(KapOpen) {
		style = GetWindowLong(g_KapHwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_KapHwnd, GWL_STYLE, style);
	}
	if(Kap2Open) {
		style = GetWindowLong(g_Kap2Hwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_Kap2Hwnd, GWL_STYLE, style);
	}
	if(KarOpen) {
		style = GetWindowLong(g_KarHwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_KarHwnd, GWL_STYLE, style);
	}
	if(OutOpen) {
		style = GetWindowLong(g_OutHwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_OutHwnd, GWL_STYLE, style);
	}
	if(THETAOpen) {
		style = GetWindowLong(g_THETAHwnd, GWL_STYLE);
		style &= WS_MAXIMIZEBOX;
		SetWindowLong(g_THETAHwnd, GWL_STYLE, style);
	}
}

void GlobalVars::PauseLoop()
{
	while (IsPause)
		;
}

BOOL GlobalVars::IsValidFile(LPCSTR lpszFile)
{
	OFSTRUCT of;
	if(OpenFile(lpszFile, &of, OF_EXIST) == HFILE_ERROR) {
		return FALSE;
	}
	else {
		return TRUE;
	}
}
