// OUTView.h : interface of the COUTView class
//
/////////////////////////////////////////////////////////////////////////////

#include "gendoc.h"

class COUTView : public CScrollView
{
protected: // create from serialization only
	CSize 	m_ViewCharSize;	
	CSize	m_DocSize;		
	CFont*	m_pFont;		
	void ComputeViewMetrics();
	int ComputeVisibleLines(CDC* pDC, int& nFirst, int& nLast);
	CStringList* GetLineList();

	COUTView();
	DECLARE_DYNCREATE(COUTView)

// Attributes
public:
	CGenericDoc* GetDocument();
	CSize	GetDocSize() const { return m_DocSize; }
	CSize	GetCharSize() const { return m_ViewCharSize; }
	CFont*	GetFont();
	//print
	int			GetLinesPerPrintPage() const 
									{ return m_nLinesPerPrintPage; }
	int			GetPrintPageCount() const {	return m_nPrintPages; }


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COUTView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
//	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

public:
	virtual void OnDraw(CDC* pDC, int nFirstLn, int nLastLn, int nXPos = 0, int nYPos = 0);   
	void OnUpdate();

	CSize 	m_PrintCharSize;		//	Dimension of printer character in device units
	int		m_nLinesPerPrintPage;	//	Lines of text per print page
	int		m_nPrintPages;			//	Number of print pages in document

	//print
	CDC* CreatePrinterDC(); 
	void ComputePrintMetrics();
	void ComputePrintableLines( CDC* pDC, CPrintInfo* pInfo, 
								int& nFirst, int& nLast);
// Implementation
public:
	virtual ~COUTView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	// Generated message map functions
protected:
	//{{AFX_MSG(COUTView)
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnRunStop();
	afx_msg void OnUpdateRunStop(CCmdUI* pCmdUI);
	afx_msg void OnRunPause();
	afx_msg void OnUpdateRunPause(CCmdUI* pCmdUI);
	afx_msg void OnRunResume();
	afx_msg void OnUpdateRunResume(CCmdUI* pCmdUI);
	afx_msg void OnRunRun();
	afx_msg void OnUpdateRunRun(CCmdUI* pCmdUI);
	afx_msg void OnCloseAllWins();
	afx_msg void OnUpdateCloseAllWins(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFormatFont();
	//}}AFX_MSG
	afx_msg LRESULT OnUserInvalOut(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserCloseOut(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in OUTView.cpp
inline CGenericDoc* COUTView::GetDocument()
   { return (CGenericDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
