// Property.cpp : implementation file
//

#include <string.h>
#include "stdafx.h"
#include "BAMBE.h"
#include "Property.h"
#include "FileRoot.h"
#include "UserList.h"
#include "Window.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern Windows win;		// to be passed to main in CallMain
extern CBAMBEApp* pBApp;
extern int main ();

UINT idc_init_kappa[10] = {IDC_INIT_KAPPA1, IDC_INIT_KAPPA2, IDC_INIT_KAPPA3,
	IDC_INIT_KAPPA4, IDC_INIT_KAPPA5, IDC_INIT_KAPPA6, IDC_INIT_KAPPA7,
	IDC_INIT_KAPPA8, IDC_INIT_KAPPA9, IDC_INIT_KAPPA10};

UINT idc_init_theta[10] = {IDC_INIT_THETA1, IDC_INIT_THETA2, IDC_INIT_THETA3,
	IDC_INIT_THETA4, IDC_INIT_THETA5, IDC_INIT_THETA6, IDC_INIT_THETA7,
	IDC_INIT_THETA8, IDC_INIT_THETA9, IDC_INIT_THETA10};

/////////////////////////////////////////////////////////////////////////////
// CProbModel Dialog Box
void add_category(int n, int *categories)
{
  int *i,*j;

  for(i=categories;i<categories+ pBApp->globals.num_tags && *i<=n;i++)
    if(*i == n)
      return;
  for(j=categories+pBApp->globals.num_tags;j>i;j--)
    *j = *(j-1);
  *j = n;
  pBApp->globals.num_tags++;
}


static DWORD aProbHelpIDs[] = 
{
	IDC_LIKELIHOOD, HIDD_LIKELIHOOD,
	IDC_RADIO2, HIDD_LIKELIHOOD,
	IDC_RADIO1, HIDD_LIKELIHOOD,
	IDC_MOLECULAR_CLOCK, HIDD_MOLECULAR_CLOCK,
	IDC_RADIO4, HIDD_MOLECULAR_CLOCK,
	IDC_SINGLE_KAPPA, HIDD_SINGLE_KAPPA,
	IDC_RADIO6, HIDD_SINGLE_KAPPA,
	IDC_CAT_LIST, HIDD_CAT_LIST,
	IDC_BURN_ALG, HIDD_BURN_ALG,
//	IDC_RADIO5, HIDD_BURN_ALG,
	IDC_RADIO7, HIDD_BURN_ALG,
//	IDC_RADIO8, HIDD_BURN_ALG,
	IDC_MAIN_ALG, HIDD_MAIN_ALG,
//	IDC_RADIO9, HIDD_MAIN_ALG,
	IDC_RADIO10, HIDD_MAIN_ALG,
//	IDC_RADIO11, HIDD_MAIN_ALG,
	IDC_ADVANCED, HIDD_ADVANCED,
	IDC_NEXT, HIDD_DIALOG_NEXT,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	0, 0
};

IMPLEMENT_DYNCREATE(CProbModel, CDialog)

CProbModel::CProbModel() : CDialog(CProbModel::IDD)
{
	// Initial values for the General Information dialog

	//{{AFX_DATA_INIT(CProbModel)
	m_likelihood_model = 0;
	m_molecular_clock = 0;
	m_single_kappa = 1;
	m_burn_algorithm = 0;
	m_main_algorithm = 1;
	m_cat_list = 0;
	m_ck_beta = TRUE;
	//}}AFX_DATA_INIT
}

CProbModel::~CProbModel()
{
}

void CProbModel::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProbModel)
	DDX_Radio(pDX, IDC_LIKELIHOOD, m_likelihood_model);
	DDX_Radio(pDX, IDC_MOLECULAR_CLOCK, m_molecular_clock);
	DDX_Radio(pDX, IDC_SINGLE_KAPPA, m_single_kappa);
	DDX_Radio(pDX, IDC_BURN_ALG, m_burn_algorithm);
	DDX_Radio(pDX, IDC_MAIN_ALG, m_main_algorithm);
	DDX_Radio(pDX, IDC_CAT_LIST, m_cat_list);
	DDX_Check(pDX, IDC_LOCAL_BETA, m_ck_beta);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProbModel, CDialog)
	//{{AFX_MSG_MAP(CProbModel)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_WM_HELPINFO()
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_CAT_LIST, OnCatList)
	ON_BN_CLICKED(IDC_CAT_LIST3, OnCatList3)
	ON_BN_CLICKED(IDC_ADVANCED, OnAdvanced)
	ON_BN_CLICKED(IDC_MAIN_ALG, OnChangeAlg)
	ON_BN_CLICKED(IDC_CAT_LIST2, OnCatList)
	ON_BN_CLICKED(IDC_BURN_ALG, OnChangeAlg)
	ON_BN_CLICKED(IDC_RADIO10, OnChangeAlg)
	ON_BN_CLICKED(IDC_RADIO7, OnChangeAlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CProbModel::GetInfoProb()
{
		pBApp->globals.model = m_likelihood_model;
		pBApp->globals.mclock = (m_molecular_clock ? 0 : 1);
		pBApp->globals.burn_algorithm = m_burn_algorithm;
		pBApp->globals.main_algorithm = m_main_algorithm;
		pBApp->globals.single_kappa = (m_single_kappa ? 0 : 1);
		pBApp->globals.use_beta = (m_ck_beta ? 1 : 0);

		pBApp->globals.cat_list_val = m_cat_list;

		TRACE("likelihood model %d\n", pBApp->globals.model);
		TRACE("molecular clock %d\n", pBApp->globals.mclock );
		TRACE("# categories %d\n", pBApp->globals.num_categories);
		TRACE("single kappa %d\n", pBApp->globals.single_kappa);
		TRACE("burn alg %d\n", pBApp->globals.burn_algorithm);
		TRACE("main alg %d\n\n", pBApp->globals.main_algorithm);
}

void CProbModel::SetDefaultValues()
{
	m_likelihood_model = 0;
	m_molecular_clock = 0;
	m_single_kappa = 1;
	m_burn_algorithm = 0;
	m_main_algorithm = 1;
	m_cat_list = 0;
}

void CProbModel::SetChangedValues()
{
	m_likelihood_model = pBApp->globals.model;
	m_molecular_clock = (pBApp->globals.mclock ? 0 : 1);
	m_single_kappa = (pBApp->globals.single_kappa ? 0 : 1);
	m_burn_algorithm = pBApp->globals.burn_algorithm;
	m_main_algorithm = pBApp->globals.main_algorithm;
	m_cat_list = pBApp->globals.cat_list_val;
	m_ck_beta = pBApp->globals.use_beta;
}
/////////////////////////////////////////////////////////////////////////////
// CProbModel message handlers
BOOL CProbModel::OnInitDialog() 
{
	if (pBApp->globals.IsChange) 
		SetChangedValues();
	//else SetDefaultValues();

	CDialog::OnInitDialog();

	CWnd *pBox;

	if (m_burn_algorithm == 0 && m_main_algorithm == 0) {
		pBox = GetDlgItem(IDC_LOCAL_BETA);
		if (pBox)
			pBox->EnableWindow(FALSE);
	}

	pBox = GetDlgItem(IDC_ADVANCED);
	if (pBApp->globals.cat_list_val == 0 || 
		pBApp->globals.cat_list_val == 1) {
		if (pBox)
			pBox->EnableWindow(FALSE);
	}
	else {
		if (pBox)
			pBox->EnableWindow(TRUE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CProbModel::OnOK() 
{
// dummy function
}

// WINDOWS VERSION of get_categories (with message boxes)
int my_get_categories(HWND hWnd, char **str, int *categories) 
{
	int n;
	int flag;
	CString ErrMsg;

	while(isspace(**str))
		(*str)++;
	if(**str == '(') {
		(*str)++;
	    if(!my_get_categories(hWnd, str,categories)) {
			ErrMsg = "Error: Empty group in category list.";
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}

		while(isspace(**str))
			(*str)++;
	    if(**str == '*') {
			ErrMsg = "Error: Asterisk must be the last symbol in the category list.";
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}

	    if(**str != ')') {
			ErrMsg = "Error: Mismatched parentheses in category list.";
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}

	    (*str)++;
	}
	else if(isdigit(**str)) {
		n = **str - '0';
		for((*str)++;isdigit(**str);(*str)++)
			n = 10 * n + **str - '0';
		if(n == 0) {
			ErrMsg = "Error: Category must be a positive number in category list.";
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}
		else if(n > MAX_CATEGORIES) {
	        ErrMsg.Format("Error: Category must be less than or equal to %d in "
		      "category list.", MAX_CATEGORIES);
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
		    return 0;
		}

		add_category(n,categories);
	}
	else 
		return 0;

	while(isspace(**str))
		(*str)++;
	if(**str == '^') {
		(*str)++;
		while(isspace(**str))
			(*str)++;
		if(!isdigit(**str)) {
			ErrMsg = "Error: Repeat count must be an integer in the category list.";
			MessageBox (hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}
		n = **str - '0';
		for((*str)++;isdigit(**str);(*str)++)
			n = 10 * n + **str - '0';
		if(n == 0) {
			ErrMsg = "Error: Repeat count may not be zero in the category list.";
			MessageBox(hWnd, ErrMsg, NULL, MB_OK);
			return 0;
		}

		while(isspace(**str))
			(*str)++;
	}

	if(**str == ',') {
		(*str)++;
		flag = my_get_categories(hWnd, str,categories);
		if (flag == 0)
			return flag;
	}
	return 1;
}

int CalculateCatlist(HWND hWnd)
{
	int flag = 1;
	char *stringval, *p;
	p = stringval = NULL;
	CString ErrMsg;

	stringval = new char[pBApp->globals.userlist.GetLength()+1];		//[strlen(userlist)+1];
	strcpy(stringval, pBApp->globals.userlist);
	p = stringval;

	strcpy(pBApp->globals.category_list,stringval);
	pBApp->globals.num_tags = 0;

	if(!my_get_categories(hWnd,&stringval,pBApp->globals.categories)) {
		ErrMsg = "Error: Empty category list ";		// should not happen - my case takes care of this
		MessageBox (hWnd, ErrMsg, NULL, MB_OK);
		delete p;	// p points to stringval
		return 0;
      }
 
	if(*stringval == '*') {
		(stringval)++;
		while(isspace(*stringval))
			(stringval)++;
	}

	if(*stringval != '\0') {
		ErrMsg = "Error: Category list ends badly ";
		MessageBox (hWnd, ErrMsg, NULL, MB_OK);
		delete p;	// p points to stringval
		return 0;
	}

    pBApp->globals.num_categories = pBApp->globals.categories[pBApp->globals.num_tags-1];

	stringval = p;
	if (stringval != NULL) {
		delete stringval;
	}

	return flag;
}

void CProbModel::OnNext() 
{
	UpdateData();

	int flag = 1;
	CString ErrMsg;

	if (m_cat_list == 0) {
		pBApp->globals.userlist.Format("1*");
	}
	else if (m_cat_list == 1) {
		pBApp->globals.userlist.Format("(1,2,3)*");
	}
	else if (m_cat_list == 2 && !pBApp->globals.ulentered) {
		flag = 0;
		ErrMsg = "Error: A value must be entered for User Specified Category List.\n "
			"Press the Advanced button to do this.";
		MessageBox(ErrMsg);
	}

	if (flag) {
		HWND hWnd = GetSafeHwnd();
		flag = CalculateCatlist(hWnd);
	}

	if (flag) {
		CDialog::OnOK();	
	}
}

BOOL CProbModel::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aProbHelpIDs);
	}
	return TRUE;
	//return CDialog::OnHelpInfo(pHelpInfo);
}

void CProbModel::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aProbHelpIDs);
}

void CProbModel::OnCatList() 
{
	CWnd *pBox;

	pBApp->globals.ulentered = 0;
	pBox = GetDlgItem(IDC_ADVANCED);
	if (pBox)
		pBox->EnableWindow(FALSE);
}

void CProbModel::OnCatList3() 
{
	CWnd *pBox;

	pBApp->globals.ulentered = 0;
	pBox = GetDlgItem(IDC_ADVANCED);
	if (pBox)
		pBox->EnableWindow(TRUE);	
}

void CProbModel::OnAdvanced() 
{
	CUserList getlist;
	
	if (getlist.DoModal() == IDOK) {
		pBApp->globals.ulentered = 1;
		pBApp->globals.userlist = getlist.m_user_list;
	}
}

void CProbModel::OnChangeAlg() 
{
	UpdateData();

	CWnd *pBox;
		pBox = GetDlgItem(IDC_LOCAL_BETA);

	if (m_burn_algorithm == 0 && m_main_algorithm == 0) {
		if (pBox)
			pBox->EnableWindow(FALSE);
	}	
	else {
		if (pBox)
			pBox->EnableWindow(TRUE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CModelParam Dialog Box
static DWORD aRun2HelpIDs[] = 
{
	IDC_INIT_KAPPA1, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA2, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA3, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA4, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA5, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA6, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA7, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA8, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA9, HIDD_INIT_KAPPA,
	IDC_INIT_KAPPA10, HIDD_INIT_KAPPA,
	IDC_INIT_THETA1, HIDD_INIT_THETA,
	IDC_INIT_THETA2, HIDD_INIT_THETA,
	IDC_INIT_THETA3, HIDD_INIT_THETA,
	IDC_INIT_THETA4, HIDD_INIT_THETA,
	IDC_INIT_THETA5, HIDD_INIT_THETA,
	IDC_INIT_THETA6, HIDD_INIT_THETA,
	IDC_INIT_THETA7, HIDD_INIT_THETA,
	IDC_INIT_THETA8, HIDD_INIT_THETA,
	IDC_INIT_THETA9, HIDD_INIT_THETA,
	IDC_INIT_THETA10, HIDD_INIT_THETA,
	IDC_PARAMUP_SPIN1, HIDD_PARAMUP_SPIN1,
	IDC_CHECK_KAPPA, HIDD_PARAMS_UPD,
	IDC_CHECK_THETA, HIDD_PARAMS_UPD,
	IDC_CHECK_PI, HIDD_PARAMS_UPD,
	IDC_ESTIMATE_PI, HIDD_ESTIMATE_PI,
	IDC_RADIO2, HIDD_ESTIMATE_PI,
	IDC_BACK, HIDD_DIALOG_BACK,
	IDC_NEXT, HIDD_DIALOG_NEXT,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	0, 0
};

IMPLEMENT_DYNCREATE(CModelParam, CDialog)

CModelParam::CModelParam(CWnd* pParent /*=NULL*/)
	: CDialog(CModelParam::IDD, pParent)
{
// Initial values for the other Run Characteristics property page
	
	//{{AFX_DATA_INIT(CModelParam)
	m_parameter_update_interval = 0;
	m_initial_kappa1 = 2.0;
	m_initial_kappa10 = 2.0;
	m_initial_kappa2 = 2.0;
	m_initial_kappa3 = 2.0;
	m_initial_kappa4 = 2.0;
	m_initial_kappa5 = 2.0;
	m_initial_kappa6 = 2.0;
	m_initial_kappa7 = 2.0;
	m_initial_kappa8 = 2.0;
	m_initial_kappa9 = 2.0;
	m_initial_theta1 = 1.0;
	m_initial_theta10 = 1.0;
	m_initial_theta2 = 1.0;
	m_initial_theta3 = 1.0;
	m_initial_theta4 = 1.0;
	m_initial_theta5 = 1.0;
	m_initial_theta6 = 1.0;
	m_initial_theta7 = 1.0;
	m_initial_theta8 = 1.0;
	m_initial_theta9 = 1.0;
	m_ck_kappa = TRUE;
	m_ck_pi = TRUE;
	m_ck_theta = TRUE;
	m_estimate_pi = 0;
	m_ck_ttp = TRUE;
	m_ck_gamma = TRUE;
	//}}AFX_DATA_INIT
}


void CModelParam::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModelParam)
	DDX_Text(pDX, IDC_PARAMUP_SPIN1, m_parameter_update_interval);
	DDX_Text(pDX, IDC_INIT_KAPPA1, m_initial_kappa1);
	DDX_Text(pDX, IDC_INIT_KAPPA10, m_initial_kappa10);
	DDX_Text(pDX, IDC_INIT_KAPPA2, m_initial_kappa2);
	DDX_Text(pDX, IDC_INIT_KAPPA3, m_initial_kappa3);
	DDX_Text(pDX, IDC_INIT_KAPPA4, m_initial_kappa4);
	DDX_Text(pDX, IDC_INIT_KAPPA5, m_initial_kappa5);
	DDX_Text(pDX, IDC_INIT_KAPPA6, m_initial_kappa6);
	DDX_Text(pDX, IDC_INIT_KAPPA7, m_initial_kappa7);
	DDX_Text(pDX, IDC_INIT_KAPPA8, m_initial_kappa8);
	DDX_Text(pDX, IDC_INIT_KAPPA9, m_initial_kappa9);
	DDX_Text(pDX, IDC_INIT_THETA1, m_initial_theta1);
	DDX_Text(pDX, IDC_INIT_THETA10, m_initial_theta10);
	DDX_Text(pDX, IDC_INIT_THETA2, m_initial_theta2);
	DDX_Text(pDX, IDC_INIT_THETA3, m_initial_theta3);
	DDX_Text(pDX, IDC_INIT_THETA4, m_initial_theta4);
	DDX_Text(pDX, IDC_INIT_THETA5, m_initial_theta5);
	DDX_Text(pDX, IDC_INIT_THETA6, m_initial_theta6);
	DDX_Text(pDX, IDC_INIT_THETA7, m_initial_theta7);
	DDX_Text(pDX, IDC_INIT_THETA8, m_initial_theta8);
	DDX_Text(pDX, IDC_INIT_THETA9, m_initial_theta9);
	DDX_Check(pDX, IDC_CHECK_KAPPA, m_ck_kappa);
	DDX_Check(pDX, IDC_CHECK_PI, m_ck_pi);
	DDX_Check(pDX, IDC_CHECK_THETA, m_ck_theta);
	DDX_Radio(pDX, IDC_ESTIMATE_PI, m_estimate_pi);
	DDX_Check(pDX, IDC_CHECK_TTP, m_ck_ttp);
	DDX_Check(pDX, IDC_CHECK_GAMMA, m_ck_gamma);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModelParam, CDialog)
	//{{AFX_MSG_MAP(CModelParam)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_WM_CONTEXTMENU()
	ON_WM_HELPINFO()
	ON_EN_CHANGE(IDC_PARAMUP_SPIN1, OnChangeParamupSpin1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModelParam message handlers
void CModelParam::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aRun2HelpIDs);
}

BOOL CModelParam::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aRun2HelpIDs);
	}
	return TRUE;	
}

void CModelParam::OnBack() 
{
	if (!UpdateData(TRUE))
	{
		TRACE0("UpdateData failed during dialog termination.\n");
		// the UpdateData routine will set focus to correct item
		return;
	}

	EndDialog(IDC_BACK);	
}

void CModelParam::OnOK() 
{
	// dummy function
}

void CModelParam::OnNext() 
{
	UpdateData();

	CString ErrMsg;
	CString name;
	int flag = 1;
	
	if ((m_initial_kappa1 <= 0)) {
		flag = 0;
		name = "Initial Kappa 1";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa2 <= 0)) {
		flag = 0;
		name = "Initial Kappa 2";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa3 <= 0)) {
		flag = 0;
		name = "Initial Kappa 3";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa4 <= 0)) {
		flag = 0;
		name = "Initial Kappa 4";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa5 <= 0)) {
		flag = 0;
		name = "Initial Kappa 5";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa6 <= 0)) {
		flag = 0;
		name = "Initial Kappa 6";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa7 <= 0)) {
		flag = 0;
		name = "Initial Kappa 7";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa8 <= 0)) {
		flag = 0;
		name = "Initial Kappa 8";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa9 <= 0)) {
		flag = 0;
		name = "Initial Kappa 9";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if ((m_initial_kappa10 <= 0)) {
		flag = 0;
		name = "Initial Kappa 10";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}

	if ((m_initial_theta1 < 0)) {
		flag = 0;
		name = "Initial Theta 1";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta2 < 0)) {
		flag = 0;
		name = "Initial Theta 2";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta3 < 0)) {
		flag = 0;
		name = "Initial Theta 3";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta4 < 0)) {
		flag = 0;
		name = "Initial Theta 4";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta5 < 0)) {
		flag = 0;
		name = "Initial Theta 5";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta6 < 0)) {
		flag = 0;
		name = "Initial Theta 6";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta7 < 0)) {
		flag = 0;
		name = "Initial Theta 7";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta8 < 0)) {
		flag = 0;
		name = "Initial Theta 8";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta9 < 0)) {
		flag = 0;
		name = "Initial Theta 9";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	if ((m_initial_theta10 < 0)) {
		flag = 0;
		name = "Initial Theta 10";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	

	if (m_parameter_update_interval < 0) {
		flag = 0;
		name = "Parameter Update Interval";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	

	if (flag) {
		CDialog::OnOK();
	}
}

void CModelParam::GetInfoModelParam()
{
	pBApp->globals.param_update_interval = m_parameter_update_interval;
	pBApp->globals.update_kappa = (m_ck_kappa ? 1 : 0);
	pBApp->globals.update_theta = (m_ck_theta ? 1 : 0);
	pBApp->globals.update_pi = (m_ck_pi ? 1 : 0);
	pBApp->globals.update_gamma = (m_ck_gamma ? 1 : 0);
	pBApp->globals.update_ttp = (m_ck_ttp ? 1 : 0);

	pBApp->globals.estimate_pi = (m_estimate_pi ? 0 : 1); // backwards because of the order of the options in the dialog box

	pBApp->globals.input_kappa[0] = m_initial_kappa1;
	pBApp->globals.input_kappa[1] = m_initial_kappa2;
	pBApp->globals.input_kappa[2] = m_initial_kappa3;
	pBApp->globals.input_kappa[3] = m_initial_kappa4;
	pBApp->globals.input_kappa[4] = m_initial_kappa5;
	pBApp->globals.input_kappa[5] = m_initial_kappa6;
	pBApp->globals.input_kappa[6] = m_initial_kappa7;
	pBApp->globals.input_kappa[7] = m_initial_kappa8;
	pBApp->globals.input_kappa[8] = m_initial_kappa9;
	pBApp->globals.input_kappa[9] = m_initial_kappa10;
	
	pBApp->globals.input_theta[0] = m_initial_theta1;
	pBApp->globals.input_theta[1] = m_initial_theta2;
	pBApp->globals.input_theta[2] = m_initial_theta3;
	pBApp->globals.input_theta[3] = m_initial_theta4;
	pBApp->globals.input_theta[4] = m_initial_theta5;
	pBApp->globals.input_theta[5] = m_initial_theta6;
	pBApp->globals.input_theta[6] = m_initial_theta7;
	pBApp->globals.input_theta[7] = m_initial_theta8;
	pBApp->globals.input_theta[8] = m_initial_theta9;
	pBApp->globals.input_theta[9] = m_initial_theta10;

	for (int i = 0; i < 10; i++) {
		TRACE("init kapp[%d] = %f, theta = %f\n", i, pBApp->globals.input_kappa[i], pBApp->globals.input_theta[i]);
	}

	TRACE("paramter update interval  %d\n", pBApp->globals.param_update_interval);
}

void CModelParam::UpdateChecks(BOOL val) 
{
	CWnd *pBox = GetDlgItem(IDC_STATIC_PU);
	if (pBox)
		pBox->EnableWindow(val);

	BOOL Kval = (pBApp->globals.model == 2 && val ? FALSE : val);
	pBox = GetDlgItem(IDC_CHECK_KAPPA);
	if (pBox)
		pBox->EnableWindow(Kval);

	pBox = GetDlgItem(IDC_CHECK_THETA);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_CHECK_PI);
	if (pBox)
		pBox->EnableWindow(val);

	val = (pBApp->globals.model == 2 && val ? TRUE : FALSE);
	
	pBox = GetDlgItem(IDC_CHECK_TTP);
	if (pBox)
		pBox->EnableWindow(val);
	pBox = GetDlgItem(IDC_CHECK_GAMMA);
	if (pBox)
		pBox->EnableWindow(val);
}

void CModelParam::OnChangeParamupSpin1() 
{
	UINT num = GetDlgItemInt(IDC_PARAMUP_SPIN1);

	if (num > 0) {
		UpdateChecks(TRUE);
	}
	else {
		UpdateChecks(FALSE);
	}
}

void CModelParam::SetDefaultValues()
{
	m_parameter_update_interval = 0;
	m_initial_kappa1 = 2.0;
	m_initial_kappa10 = 2.0;
	m_initial_kappa2 = 2.0;
	m_initial_kappa3 = 2.0;
	m_initial_kappa4 = 2.0;
	m_initial_kappa5 = 2.0;
	m_initial_kappa6 = 2.0;
	m_initial_kappa7 = 2.0;
	m_initial_kappa8 = 2.0;
	m_initial_kappa9 = 2.0;
	m_initial_theta1 = 1.0;
	m_initial_theta10 = 1.0;
	m_initial_theta2 = 1.0;
	m_initial_theta3 = 1.0;
	m_initial_theta4 = 1.0;
	m_initial_theta5 = 1.0;
	m_initial_theta6 = 1.0;
	m_initial_theta7 = 1.0;
	m_initial_theta8 = 1.0;
	m_initial_theta9 = 1.0;
	m_ck_kappa = TRUE;
	m_ck_pi = TRUE;
	m_ck_theta = TRUE;
	m_estimate_pi = 0;
	m_ck_ttp = TRUE;
	m_ck_gamma = TRUE;
}

void CModelParam::SetChangedValues()
{
	m_parameter_update_interval = pBApp->globals.param_update_interval;
	m_initial_kappa1 = pBApp->globals.input_kappa[0];
	m_initial_kappa10 = pBApp->globals.input_kappa[9];
	m_initial_kappa2 = pBApp->globals.input_kappa[1];
	m_initial_kappa3 = pBApp->globals.input_kappa[2];
	m_initial_kappa4 = pBApp->globals.input_kappa[3];
	m_initial_kappa5 = pBApp->globals.input_kappa[4];
	m_initial_kappa6 = pBApp->globals.input_kappa[5];
	m_initial_kappa7 = pBApp->globals.input_kappa[6];
	m_initial_kappa8 = pBApp->globals.input_kappa[7];
	m_initial_kappa9 = pBApp->globals.input_kappa[8];
	m_initial_theta1 = pBApp->globals.input_theta[0];
	m_initial_theta10 = pBApp->globals.input_theta[9];
	m_initial_theta2 = pBApp->globals.input_theta[1];
	m_initial_theta3 = pBApp->globals.input_theta[2];
	m_initial_theta4 = pBApp->globals.input_theta[3];
	m_initial_theta5 = pBApp->globals.input_theta[4];
	m_initial_theta6 = pBApp->globals.input_theta[5];
	m_initial_theta7 = pBApp->globals.input_theta[6];
	m_initial_theta8 = pBApp->globals.input_theta[7];
	m_initial_theta9 = pBApp->globals.input_theta[8];
	m_ck_kappa = pBApp->globals.update_kappa ? TRUE : FALSE;
	m_ck_pi = pBApp->globals.update_pi ? TRUE : FALSE;;
	m_ck_theta = pBApp->globals.update_theta ? TRUE : FALSE;;
	m_estimate_pi = pBApp->globals.estimate_pi ? 0 : 1;
	m_ck_ttp = pBApp->globals.update_ttp ? TRUE : FALSE;;
	m_ck_gamma = pBApp->globals.update_gamma ? TRUE : FALSE;;
}

BOOL CModelParam::OnInitDialog() 
{
	if (pBApp->globals.IsChange) 
		SetChangedValues();
	//else SetDefaultValues();

	CDialog::OnInitDialog();

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*) GetDlgItem(IDC_SPIN1);
	pSpin->SetRange(0, 10000);

	if (pBApp->globals.model == 2) {
		DisableInitsAll(idc_init_kappa);
	}
	else {
		DisableInits(idc_init_kappa, TRUE);	
	}
	DisableInits(idc_init_theta, FALSE);

	UINT Param_num = GetDlgItemInt(IDC_PARAMUP_SPIN1);

	CWnd *pBox;
	if(Param_num == 0) 
		UpdateChecks(FALSE);
	else 
		UpdateChecks(TRUE);

	if(pBApp->globals.mclock) {
		pBox = GetDlgItem(IDC_RADIO2);
		if (pBox)
			pBox->EnableWindow(FALSE);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CModelParam::DisableInitsAll(UINT *pInits)
{
	CWnd* ed;
	for (UINT i = 0; i < 10; i++) {
		ed = GetDlgItem(pInits[i]);
		if (ed) {
			ed->EnableWindow(FALSE);
		}
	}
}

void CModelParam::DisableInits(UINT *pInits, BOOL IsKappa)
{
	CWnd* ed;
	for (UINT i = 0; i < 10; i++) {
		ed = GetDlgItem(pInits[i]);
		if (ed) {
			ed->EnableWindow(FALSE);
		}
	}
	UINT end = pBApp->globals.num_tags;
	if (IsKappa && pBApp->globals.single_kappa)
		end = 1;

	for(i = 0; i < end; i++) {
		ed = GetDlgItem(pInits[pBApp->globals.categories[i]-1]);
		if(ed) {
			ed->EnableWindow(TRUE);
		}
	}
}
       

/////////////////////////////////////////////////////////////////////////////
// CRunCharac Dialog Box

static DWORD aRunHelpIDs[] = 
{
	IDC_DATA_FILE, HIDD_DATA_FILE,
	IDC_BROWSE1, HIDD_BROWSE,
	IDC_INIT_TREE, HIDD_INIT_TREE,
	IDC_INIT_TREE2, HIDD_INIT_TREE,
	IDC_RADIO1, HIDD_INIT_TREE,
	IDC_RADIO2, HIDD_INIT_TREE,
	IDC_INPUT_FORMAT, HIDD_INIT_TREE,
	IDC_INPUT_FORMAT2, HIDD_INIT_TREE,
	IDC_TREE_HEIGHT, HIDD_TREE_HEIGHT,
	IDC_STATIC_MAX, HIDD_TREE_HEIGHT,
	IDC_TREE_FILE, HIDD_TREE_FILE,
	IDC_STATIC_TREE, HIDD_TREE_FILE,
	IDC_BROWSE2, HIDD_BROWSE,
	IDC_BURN, HIDD_BURN,
	IDC_SEED, HIDD_SEED,
	IDC_CYCLES, HIDD_CYCLES,
	IDC_TUNE_INT, HIDD_TUNE_INT,
	IDC_STATIC_TUNE, HIDD_TUNE_INT,
	IDC_BACK, HIDD_DIALOG_BACK,
	IDC_NEXT, HIDD_DIALOG_NEXT,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	IDC_OUTGROUP_SPIN2, HIDD_OUTGROUP,
	IDC_STATIC_OUTGROUP, HIDD_OUTGROUP,
	0,0
};

IMPLEMENT_DYNCREATE(CRunCharac, CDialog)

CRunCharac::CRunCharac() : CDialog(CRunCharac::IDD)
{
	// Initial values for the Run Characteristics dialog

	//{{AFX_DATA_INIT(CRunCharac)
	m_seed = 194024933;
	m_cycles = 6000;
	m_burn = 1000;
	m_tune_int = 200;
	m_max_initial_tree_height = 0.1;
	m_data_file = _T("");
	m_tree_file = _T("");
	m_init_tree = 0;
	m_outgroup = 1;
	m_input_format = 0;
	//}}AFX_DATA_INIT
}

CRunCharac::~CRunCharac()
{
}

void CRunCharac::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRunCharac)
	DDX_Text(pDX, IDC_SEED, m_seed);
	DDX_Text(pDX, IDC_CYCLES, m_cycles);
	DDX_Text(pDX, IDC_BURN, m_burn);
	DDX_Text(pDX, IDC_TUNE_INT, m_tune_int);
	DDX_Text(pDX, IDC_TREE_HEIGHT, m_max_initial_tree_height);
	DDX_Text(pDX, IDC_DATA_FILE, m_data_file);
	DDV_MaxChars(pDX, m_data_file, 80);
	DDX_Text(pDX, IDC_TREE_FILE, m_tree_file);
	DDV_MaxChars(pDX, m_tree_file, 80);
	DDX_Radio(pDX, IDC_INIT_TREE, m_init_tree);
	DDX_Text(pDX, IDC_OUTGROUP_SPIN2, m_outgroup);
	DDX_Radio(pDX, IDC_INPUT_FORMAT, m_input_format);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRunCharac, CDialog)
	//{{AFX_MSG_MAP(CRunCharac)
	ON_BN_CLICKED(IDC_BROWSE1, OnBrowse1)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_INIT_TREE, OnInitTree)
	ON_BN_CLICKED(IDC_INIT_TREE2, OnInitTree2)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_WM_CONTEXTMENU()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_RADIO1, OnInitTreeOther)
	ON_BN_CLICKED(IDC_RADIO2, OnInitTreeOther)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CRunCharac::GetInfoRun()
{
	pBApp->globals.max_depth = m_max_initial_tree_height;
	pBApp->globals.tune_interval = m_tune_int;
	pBApp->globals.seed = m_seed % (1<<31);
	//pBApp->globals.seedValue = m_seed;
	pBApp->globals.burn = m_burn;
	pBApp->globals.num_cycles = m_cycles;
	pBApp->globals.init_tree = m_init_tree;
	pBApp->globals.init_tree_format = (m_input_format ? 0 : 1);
	pBApp->globals.outgroup = m_outgroup;
	
	switch(m_init_tree) {
		case 0: m_tree_file = "random"; break;
		case 1: m_tree_file = "UPGMA"; break;
		case 2: m_tree_file = "Neighbor-joining"; break;
		case 3: break; // just get the name of the file
	}

	strcpy(pBApp->globals.tree_file, m_tree_file);		
	strcpy(pBApp->globals.data_file, m_data_file);

	TRACE("Burn %d\n", pBApp->globals.burn);
	TRACE("cycles %d\n", pBApp->globals.num_cycles);
	TRACE("tune_interval %d\n", pBApp->globals.tune_interval);
	TRACE("seed %d\n", pBApp->globals.seed);
	TRACE("outgroup %d\n", pBApp->globals.outgroup);

	TRACE("data file %s\n", pBApp->globals.data_file);
	TRACE("tree file %s\n", pBApp->globals.tree_file);
	TRACE("max init %f\n", pBApp->globals.max_depth);
}

/////////////////////////////////////////////////////////////////////////////
// CRunCharac message handlers

void CRunCharac::OnBrowse1() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.*",NULL,"*.*");

	if (getFile.DoModal() == IDOK)
	{
		m_data_file = getFile.GetPathName();
		TRACE("OnBrowse1, %s\n", m_data_file);
	}	
	UpdateData(FALSE);
}

void CRunCharac::OnBrowse2() 
{
	UpdateData();
	CFileDialog getFile(TRUE, NULL,"*.*", NULL, "*.*");

	if (getFile.DoModal() == IDOK)
	{
		m_tree_file = getFile.GetPathName();
		TRACE("OnBrowse2, %s\n", m_tree_file);
	}		
	UpdateData(FALSE);	
}

void CRunCharac::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aRunHelpIDs);
}

BOOL CRunCharac::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aRunHelpIDs);
	}
	return TRUE;	
}

void CRunCharac::OnOK() 
{
// dummy function
}

void CRunCharac::OnBack() 
{
	if (!UpdateData(TRUE))
	{
		TRACE0("UpdateData failed during dialog termination.\n");
		// the UpdateData routine will set focus to correct item
		return;
	}

	EndDialog(IDC_BACK);	
}

void CRunCharac::OnNext() 
{
	UpdateData();

	BOOL tree, data;
	CString ErrMsg;
	CString name;
	int flag = 1;

	if (m_burn < 0) {
		flag = 0;
		name = "Cycles for Burn-in";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}	
	
	if (m_cycles < 0) {
		flag = 0;
		name = "Cycles";
		AfxFormatString1(ErrMsg, IDS_ERR_NEGATIVE, name);
		MessageBox (ErrMsg);
	}
	if (m_tune_int < 1) {
		flag = 0;
		name = "Tune Interval";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}	

	if (m_outgroup < 1) {
		flag = 0;
		name = "Outgroup";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}	

	if (m_init_tree == 3)
		tree = pBApp->globals.IsValidFile(m_tree_file);
	else
		tree = TRUE;

	data = pBApp->globals.IsValidFile(m_data_file);

	if (!data) {
		flag = 0;
		AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_data_file);
		MessageBox (ErrMsg);
	}
	if(!tree) {
		flag = 0;
		AfxFormatString1(ErrMsg, IDS_ERR_INVALIDFILE, m_tree_file);
		MessageBox (ErrMsg);
	}
	if (m_max_initial_tree_height <= 0) {
		flag = 0;
		name = "Maximum Initial Tree Height";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}

	if (flag) {
		CDialog::OnOK();
	}
}

void CRunCharac::SetDefaultValues()
{
	m_seed = 194024933;
	m_cycles = 6000;
	m_burn = 1000;
	m_tune_int = 200;
	m_max_initial_tree_height = 0.1;
	m_data_file.Format("");
	m_tree_file.Format("");
	m_init_tree = 0;
	m_outgroup = 1;
	m_input_format = 0;
}

void CRunCharac::SetChangedValues()
{
	m_seed = pBApp->globals.seed;
	m_cycles = pBApp->globals.num_cycles;
	m_burn = pBApp->globals.burn;
	m_tune_int = pBApp->globals.tune_interval;
	m_max_initial_tree_height = pBApp->globals.max_depth;
	m_data_file.Format("%s",pBApp->globals.data_file);
	if (pBApp->globals.init_tree == 3)
		m_tree_file.Format("%s",pBApp->globals.tree_file);
	else 
		m_tree_file.Format("");

	m_outgroup = pBApp->globals.outgroup;
	m_input_format = pBApp->globals.init_tree_format ? 0 : 1;
}

BOOL CRunCharac::OnInitDialog() 
{
	if (pBApp->globals.IsChange) 
		SetChangedValues();
	//else SetDefaultValues();

	// If the user went back and changed to a molecular clock, it can't be neighbor-joining
	if (pBApp->globals.mclock && m_init_tree == 2)
		m_init_tree = 0;

	CDialog::OnInitDialog();

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*) GetDlgItem(IDC_SPIN2);
	pSpin->SetRange(1, 10000);

	if (pBApp->globals.mclock) {
		CWnd *ed = GetDlgItem(IDC_OUTGROUP_SPIN2);	// can't chose an outgroup with mclock
		if (ed)
			ed->EnableWindow(FALSE);
		ed = GetDlgItem(IDC_STATIC_OUTGROUP);
		if (ed)
			ed->EnableWindow(FALSE);

	// If molecular clock is on, neighbor-joining can't be a choice
		ed = GetDlgItem(IDC_RADIO2);
		if (ed)
			ed->EnableWindow(FALSE);
	}

	CWnd *pBox;

	if (pBApp->globals.burn_algorithm != 0) {
		pBox = GetDlgItem(IDC_TUNE_INT);
		if (pBox)
			pBox->EnableWindow(FALSE);
		pBox = GetDlgItem(IDC_STATIC_TUNE);
		if (pBox)
			pBox->EnableWindow(FALSE);
	}

	switch(pBApp->globals.init_tree) {
	case 0: ChangeStatus(FALSE); break;
	case 1: case 2: OnInitTreeOther(); break;
	case 3: ChangeStatus(TRUE); break;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRunCharac::ChangeStatus(BOOL val)
{
	CWnd *pBox;

	pBox = GetDlgItem(IDC_TREE_FILE);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_STATIC_TREE);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_BROWSE2);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_TREE_HEIGHT);
	if (pBox)
		pBox->EnableWindow(!val);

	pBox = GetDlgItem(IDC_STATIC_MAX);
	if (pBox)
		pBox->EnableWindow(!val);

	pBox = GetDlgItem(IDC_INPUT_FORMAT);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_INPUT_FORMAT2);
	if (pBox)
		pBox->EnableWindow(val);

}

void CRunCharac::OnInitTree() 
{
	ChangeStatus(FALSE);
}

void CRunCharac::OnInitTree2() 
{
	ChangeStatus(TRUE);
}

void CRunCharac::OnInitTreeOther() 
{
	ChangeStatus(FALSE);

	CWnd* pBox = GetDlgItem(IDC_TREE_HEIGHT);
	if (pBox)
		pBox->EnableWindow(FALSE);

	pBox = GetDlgItem(IDC_STATIC_MAX);
	if (pBox)
		pBox->EnableWindow(FALSE);
}


/////////////////////////////////////////////////////////////////////////////
// CViewCharac Dialog Box

static DWORD aViewHelpIDs[] = 
{
	IDC_SAMPLEINT_SPIN2, HIDD_SAMPLEINT,
	IDC_WINDOWINT_SPIN3, HIDD_WINDOWINT,
	IDC_FILE_ROOT, HIDD_FILE_ROOT,
	IDC_SHOW_OUT_WINS, HIDD_SHOW_OUT_WINS,
	IDC_RADIO3, HIDD_SHOW_OUT_WINS,
	IDC_RADIO4, HIDD_SHOW_OUT_WINS,
	IDC_OUT_KAP, HIDD_SHOW_OUT_WINS,
	IDC_OUT_KAR, HIDD_SHOW_OUT_WINS,
	IDC_OUT_LPD1, HIDD_SHOW_OUT_WINS,
	IDC_OUT_LPD2, HIDD_SHOW_OUT_WINS,
	IDC_OUT_TAR, HIDD_SHOW_OUT_WINS,
	IDC_OUT_TOP, HIDD_SHOW_OUT_WINS,
	IDC_OUT_THETA, HIDD_SHOW_OUT_WINS,
	IDC_NEWICK, HIDD_NEWICK,
	IDC_RADIO2, HIDD_NEWICK,
	IDC_BACK, HIDD_DIALOG_BACK,
	IDC_NEXT, HIDD_DIALOG_NEXT,
	IDCANCEL, HIDD_DIALOG_CANCEL,
	0, 0
};


IMPLEMENT_DYNCREATE(CViewCharac, CDialog)

CViewCharac::CViewCharac() : CDialog(CViewCharac::IDD)
{
// Initial values for the View Characteristics dialog
	
	//{{AFX_DATA_INIT(CViewCharac)
	m_file_root = _T("run1");
	m_window_interval = 200;
	m_sample_interval = 10;		// was 200
	m_newick_format = 0;
	m_ck_KAP = TRUE;
	m_ck_KAR = TRUE;
	m_ck_LPD1 = TRUE;
	m_ck_LPD2 = TRUE;
	m_ck_TAR = TRUE;
	m_ck_TOP = TRUE;
	m_ck_THETA = TRUE;
	m_showOutW = 1;
	m_ck_GAM = TRUE;
	m_ck_TTP = TRUE;
	//}}AFX_DATA_INIT
}

CViewCharac::~CViewCharac()
{
}

void CViewCharac::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewCharac)
	DDX_Text(pDX, IDC_FILE_ROOT, m_file_root);
	DDV_MaxChars(pDX, m_file_root, 77);
	DDX_Text(pDX, IDC_WINDOWINT_SPIN3, m_window_interval);
	DDX_Text(pDX, IDC_SAMPLEINT_SPIN2, m_sample_interval);
	DDX_Radio(pDX, IDC_NEWICK, m_newick_format);
	DDX_Check(pDX, IDC_OUT_KAP, m_ck_KAP);
	DDX_Check(pDX, IDC_OUT_KAR, m_ck_KAR);
	DDX_Check(pDX, IDC_OUT_LPD1, m_ck_LPD1);
	DDX_Check(pDX, IDC_OUT_LPD2, m_ck_LPD2);
	DDX_Check(pDX, IDC_OUT_TAR, m_ck_TAR);
	DDX_Check(pDX, IDC_OUT_TOP, m_ck_TOP);
	DDX_Check(pDX, IDC_OUT_THETA, m_ck_THETA);
	DDX_Radio(pDX, IDC_SHOW_OUT_WINS, m_showOutW);
	DDX_Check(pDX, IDC_OUT_GAMMA, m_ck_GAM);
	DDX_Check(pDX, IDC_OUT_TTP, m_ck_TTP);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewCharac, CDialog)
	//{{AFX_MSG_MAP(CViewCharac)
	ON_BN_CLICKED(IDC_NEXT, OnNext)	
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_WM_CONTEXTMENU()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_SHOW_OUT_WINS, OnShowOutWins)
	ON_BN_CLICKED(IDC_RADIO3, OnShowAllOutWin)
	ON_BN_CLICKED(IDC_RADIO4, OnSelectOutWin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CViewCharac::GetInfoView()
{
	pBApp->globals.sample_interval = m_sample_interval;
	pBApp->globals.window_interval = m_window_interval;
	pBApp->globals.ShowOutput = m_showOutW;
	if(pBApp->globals.ShowOutput == 2) {
		pBApp->globals.ShowKAP = (m_ck_KAP ? 1 : 0);
		pBApp->globals.ShowKAR = m_ck_KAR ? 1 : 0;
		pBApp->globals.ShowLPD1 = m_ck_LPD1 ? 1 : 0;
		pBApp->globals.ShowLPD2 = m_ck_LPD2 ? 1 : 0;
		pBApp->globals.ShowTAR = m_ck_TAR ? 1 : 0;
		pBApp->globals.ShowTOP = m_ck_TOP ? 1 : 0;
		pBApp->globals.ShowTheta = m_ck_THETA ? 1 : 0;
		pBApp->globals.ShowTTP = m_ck_TTP ? 1 : 0;
		pBApp->globals.ShowGAM = m_ck_GAM ? 1 : 0;
	}
	else {
		pBApp->globals.ShowLPD1 = pBApp->globals.ShowLPD2= 
			pBApp->globals.ShowKAP= pBApp->globals.ShowKAR = 
			pBApp->globals.ShowTAR= pBApp->globals.ShowTOP = 
			pBApp->globals.ShowGAM= pBApp->globals.ShowTTP = 
			pBApp->globals.ShowTheta =1; 
	}
	pBApp->globals.newick_format = (m_newick_format ? 0 : 1);

	strcpy(pBApp->globals.file_root, m_file_root); 

	TRACE("file root %s\n", pBApp->globals.file_root);
	TRACE("sample inter %d\n", pBApp->globals.sample_interval);
	TRACE("win inter %d\n\n", pBApp->globals.window_interval);
}

/////////////////////////////////////////////////////////////////////////////
// CViewCharac message handlers

void CViewCharac::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	::WinHelp((HWND) *pWnd, AfxGetApp()->m_pszHelpFilePath,
		HELP_CONTEXTMENU, (DWORD)aViewHelpIDs);
}

BOOL CViewCharac::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW){
	::WinHelp((HWND)pHelpInfo->hItemHandle, 
		AfxGetApp()->m_pszHelpFilePath,
		HELP_WM_HELP, (DWORD)aViewHelpIDs);
	}
	return TRUE;	
}

void CViewCharac::SetAllOutWin(BOOL val)
{
	CWnd *pBox;

	pBox = GetDlgItem(IDC_OUT_LPD1);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_OUT_LPD2);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_OUT_KAP);
	if (pBox) {
		if (val && pBApp->globals.param_update_interval != 0 && pBApp->globals.model!=2) {
			pBox->EnableWindow(TRUE);
		}
		else {
			pBox->EnableWindow(FALSE);
		}
	}

	pBox = GetDlgItem(IDC_OUT_THETA);
	CWnd *wBox = GetDlgItem(IDC_OUT_KAR);
	if (pBox) {
		if (val && pBApp->globals.param_update_interval != 0) {
			pBox->EnableWindow(TRUE);
			TRACE("val %d TRUE\n", val);
			wBox->EnableWindow(TRUE);
		}
		else {
			pBox->EnableWindow(FALSE);
			wBox->EnableWindow(FALSE);
		}
	}

	pBox = GetDlgItem(IDC_OUT_TAR);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_OUT_TOP);
	if (pBox)
		pBox->EnableWindow(val);

	pBox = GetDlgItem(IDC_OUT_TTP);
	if (pBox) {
		if (val && pBApp->globals.param_update_interval != 0 && pBApp->globals.model==2) {
			pBox->EnableWindow(TRUE);
		}
		else {
			pBox->EnableWindow(FALSE);
		}
	}

	pBox = GetDlgItem(IDC_OUT_GAMMA);
	if (pBox) {
		if (val && pBApp->globals.param_update_interval != 0 && pBApp->globals.model==2) {
			pBox->EnableWindow(TRUE);
		}
		else {
			pBox->EnableWindow(FALSE);
		}
	}

	
	pBox = GetDlgItem(IDC_STATIC_OUTWIN);
	if(pBox)
		pBox->EnableWindow(val);
}

void CViewCharac::SetDefaultValues()
{
	m_file_root = _T("run1");
	m_window_interval = 200;
	m_sample_interval = 200;
	m_newick_format = 0;
	m_ck_KAP = TRUE;
	m_ck_KAR = TRUE;
	m_ck_LPD1 = TRUE;
	m_ck_LPD2 = TRUE;
	m_ck_TAR = TRUE;
	m_ck_TOP = TRUE;
	m_ck_THETA = TRUE;
	m_showOutW = 1;
}

void CViewCharac::SetChangedValues()
{
	m_file_root.Format("%s", pBApp->globals.file_root);
	m_window_interval = pBApp->globals.window_interval;
	m_sample_interval = pBApp->globals.sample_interval;
	m_newick_format = (pBApp->globals.newick_format ? 0 : 1);
	m_ck_KAP = pBApp->globals.ShowKAP ? TRUE : FALSE;
	m_ck_KAR = pBApp->globals.ShowKAR ? TRUE : FALSE;
	m_ck_LPD1 = pBApp->globals.ShowLPD1 ? TRUE : FALSE;
	m_ck_LPD2 = pBApp->globals.ShowLPD2 ? TRUE : FALSE;
	m_ck_TAR = pBApp->globals.ShowTAR ? TRUE : FALSE;
	m_ck_TOP = pBApp->globals.ShowTOP ? TRUE : FALSE;
	m_ck_THETA = pBApp->globals.ShowTheta ? TRUE : FALSE;
	m_ck_TTP = pBApp->globals.ShowTTP ? TRUE : FALSE;
	m_ck_GAM = pBApp->globals.ShowGAM ? TRUE : FALSE;
	m_showOutW = pBApp->globals.ShowOutput;
}

BOOL CViewCharac::OnInitDialog() 
{
	if (pBApp->globals.IsChange) 
		SetChangedValues();
	//else SetDefaultValues();

	CDialog::OnInitDialog();

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*) GetDlgItem(IDC_SPIN2);
	pSpin->SetRange(0, 10000);

	pSpin = (CSpinButtonCtrl*) GetDlgItem(IDC_SPIN3);
	pSpin->SetRange(0, 10000);

	SetAllOutWin((m_showOutW == 2));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CViewCharac::OnShowOutWins() 
{
  SetAllOutWin(FALSE);
}

void CViewCharac::OnShowAllOutWin() 
{
  SetAllOutWin(FALSE);
}

void CViewCharac::OnSelectOutWin() 
{
	SetAllOutWin(TRUE);
}

void CViewCharac::OnBack() 
{
	if (!UpdateData(TRUE))
	{
		TRACE0("UpdateData failed during dialog termination.\n");
		// the UpdateData routine will set focus to correct item
		return;
	}

	EndDialog(IDC_BACK);	
}

void CViewCharac::OnOK() 
{
	// dummy function
}

void CViewCharac::OnNext() 
{
	UpdateData(TRUE);
	int flag = 1;
	char filename[81];
	FILE *f;
	CString name, ErrMsg;

	strcpy(filename,m_file_root); 
	strcat(filename,".lpd");
	if((f = fopen(filename,"r")) != NULL) {
		pBApp->globals.go = GetNewRoot(filename);
		flag = (pBApp->globals.go==2 ? 1 : 0);
	}

	if (m_sample_interval <= 0) {
		flag = 0;
		name = "Sample Interval";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}
	if (m_window_interval <= 0) {
		flag = 0;
		name = "Window Interval";
		AfxFormatString1(ErrMsg, IDS_ERR_NONPOSITIVE, name);
		MessageBox (ErrMsg);
	}

	if (flag) {
		CDialog::OnOK();	
	}
}

void CallMain()
{
	pBApp->globals.pTemplate =	((CBAMBEApp*) AfxGetApp())->m_pTemplateOut;

	pBApp->globals.pMainWnd = AfxGetThread()->m_pMainWnd;

	int i = main();

//	pBApp->globals.EnableMaximize();
}

/*	USE THE FOLLOWING TO CONVERT TO OUR STRING FORMAT :

    char *c = new char[view.m_tree_file.GetLength()+1];
	strcpy(c, view.m_tree_file);
	outfile << "\n" << c;

 ofstream does not know how to print out the CString variables
 must convert to a pointer to a character

	delete c; */

