#define WM_USERSTATUS WM_USER + 1

#ifndef PROPERTY
#define PROPERTY

#define HIDD_LIKELIHOOD 2
#define HIDD_MOLECULAR_CLOCK 3
#define HIDD_SINGLE_KAPPA 4
#define HIDD_CAT_LIST 5
#define HIDD_BURN_ALG 6
#define HIDD_MAIN_ALG 7

#define HIDD_DIALOG_NEXT 8
#define HIDD_DIALOG_CANCEL 9
#define HIDD_DIALOG_BACK 10

#define HIDD_INIT_KAPPA 11
#define HIDD_INIT_THETA 12
#define HIDD_PARAMUP_SPIN1 13
#define HIDD_OUTGROUP 14

#define HIDD_BURN 15
#define HIDD_SEED 16
#define HIDD_CYCLES 17

#define HIDD_INIT_TTP 20
#define HIDD_INIT_GAMMA 22
//#define HIDD_INIT_R 23

#define HIDD_DATA_FILE 24
#define HIDD_BROWSE 25
#define HIDD_INIT_TREE 26
#define HIDD_TREE_HEIGHT 27
#define HIDD_TREE_FILE 28
#define HIDD_SAMPLEINT 29
#define HIDD_WINDOWINT 30
#define HIDD_FILE_ROOT 31
#define HIDD_DIALOG_OK 32

#define HIDD_SHOW_OUT_WINS 33
#define HIDD_NEWICK 34
#define HIDD_TUNE_INT 35

#define HIDD_PARAMS_UPD 38
#define HIDD_ADVANCED 39

#define HIDD_ESTIMATE_PI 40
#define HIDD_INIT_PI 41

#define MAX_CATEGORIES 10

int CalculateCatlist(HWND);
int my_get_categories(HWND, char**, int*);

// Property.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CProbModel dialog

class CProbModel : public CDialog
{
	DECLARE_DYNCREATE(CProbModel)

// Construction
public:
	CProbModel();
	~CProbModel();
	void GetInfoProb();
// Dialog Data
	//{{AFX_DATA(CProbModel)
	enum { IDD = IDD_PROP_PROBMODEL };
	int		m_likelihood_model;
	int		m_molecular_clock;
	int		m_single_kappa;
	int		m_burn_algorithm;
	int		m_main_algorithm;
	int		m_cat_list;
	BOOL	m_ck_beta;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CProbModel)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CProbModel)
	virtual void OnOK();
	afx_msg void OnNext();
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnCatList();
	afx_msg void OnCatList3();
	afx_msg void OnAdvanced();
	afx_msg void OnChangeAlg();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SetDefaultValues();
	void SetChangedValues();
};

/////////////////////////////////////////////////////////////////////////////
// CModelParam dialog

class CModelParam : public CDialog
{
	DECLARE_DYNCREATE(CModelParam)

	void UpdateChecks(BOOL);

// Construction
public:
	CModelParam(CWnd* pParent = NULL);   // standard constructor
	void GetInfoModelParam();

// Dialog Data
	//{{AFX_DATA(CModelParam)
	enum { IDD = IDD_PROP_MODEL_PARAM };
	int		m_parameter_update_interval;
	double	m_initial_kappa1;
	double	m_initial_kappa10;
	double	m_initial_kappa2;
	double	m_initial_kappa3;
	double	m_initial_kappa4;
	double	m_initial_kappa5;
	double	m_initial_kappa6;
	double	m_initial_kappa7;
	double	m_initial_kappa8;
	double	m_initial_kappa9;
	double	m_initial_theta1;
	double	m_initial_theta10;
	double	m_initial_theta2;
	double	m_initial_theta3;
	double	m_initial_theta4;
	double	m_initial_theta5;
	double	m_initial_theta6;
	double	m_initial_theta7;
	double	m_initial_theta8;
	double	m_initial_theta9;
	BOOL	m_ck_kappa;
	BOOL	m_ck_pi;
	BOOL	m_ck_theta;
	int		m_estimate_pi;
	BOOL	m_ck_ttp;
	BOOL	m_ck_gamma;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CModelParam)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CModelParam)
	virtual void OnOK();
	afx_msg void OnNext();
	virtual BOOL OnInitDialog();
	afx_msg void OnBack();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnChangeParamupSpin1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void DisableInits(UINT*, BOOL);
	void DisableInitsAll(UINT*);
	void SetDefaultValues();
	void SetChangedValues();
};


/////////////////////////////////////////////////////////////////////////////
// CRunCharac dialog

class CRunCharac : public CDialog
{
	DECLARE_DYNCREATE(CRunCharac)

	void ChangeStatus(BOOL val);

// Construction
public:
	CRunCharac();
	~CRunCharac();
	void GetInfoRun();

// Dialog Data
	//{{AFX_DATA(CRunCharac)
	enum { IDD = IDD_PROP_RCHARAC };
	int		m_seed;
	int		m_cycles;
	int		m_burn;
	int		m_tune_int;
	double	m_max_initial_tree_height;
	CString	m_data_file;
	CString	m_tree_file;
	int		m_init_tree;
	int		m_outgroup;
	int		m_input_format;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CRunCharac)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CRunCharac)
	afx_msg void OnBrowse1();
	afx_msg void OnBrowse2();
	afx_msg void OnInitTree();
	afx_msg void OnInitTree2();
	virtual void OnOK();
	afx_msg void OnNext();
	virtual BOOL OnInitDialog();
	afx_msg void OnBack();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnInitTreeOther();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SetDefaultValues();
	void SetChangedValues();
};

/////////////////////////////////////////////////////////////////////////////
// CViewCharac dialog

class CViewCharac : public CDialog
{
	DECLARE_DYNCREATE(CViewCharac)

// Construction
public:
	CViewCharac();
	~CViewCharac();
	void GetInfoView();

// Dialog Data
	//{{AFX_DATA(CViewCharac)
	enum { IDD = IDD_PROP_VCHARAC };
	CString	m_file_root;
	int		m_window_interval;
	int		m_sample_interval;
	int		m_newick_format;
	BOOL	m_ck_KAP;
	BOOL	m_ck_KAR;
	BOOL	m_ck_LPD1;
	BOOL	m_ck_LPD2;
	BOOL	m_ck_TAR;
	BOOL	m_ck_TOP;
	BOOL	m_ck_THETA;
	int		m_showOutW;
	BOOL	m_ck_GAM;
	BOOL	m_ck_TTP;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CViewCharac)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CViewCharac)
	virtual void OnOK();
	afx_msg void OnNext();
	afx_msg void OnBack();
	virtual BOOL OnInitDialog();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnShowOutWins();
	afx_msg void OnShowAllOutWin();
	afx_msg void OnSelectOutWin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void SetAllOutWin(BOOL);
	void SetDefaultValues();
	void SetChangedValues();
};

void CallMain();


#endif
