// TOPView.h : interface of the CTOPView class
//
/////////////////////////////////////////////////////////////////////////////

#include "node.h"
#include "gendoc.h"

class CTOPView : public CScrollView
{
protected: 
	int m_nPage;
	int m_nMax;

	CSize 	m_ViewCharSize;	
	CSize	m_DocSize;		
	CFont*	m_pFont;		
	int m_TotalHeight;
	double m_largestWidth;
	void ComputeViewMetrics();

	CTOPView();
	DECLARE_DYNCREATE(CTOPView)

// Attributes
public:
	CGenericDoc* GetDocument();
	CSize	GetDocSize() const { return m_DocSize; }
	CSize	GetCharSize() const { return m_ViewCharSize; }
	CFont*	GetFont();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTOPView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

public:
//	virtual void OnDraw(CDC* pDC, int nFirstLn, int nLastLn, int nXPos = 0, int nYPos = 0);
	void OnUpdate();

// Implementation
public:
	virtual ~CTOPView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	int m_longestName;
	//{{AFX_MSG(CTOPView)
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnRunStop();
	afx_msg void OnUpdateRunStop(CCmdUI* pCmdUI);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRunPause();
	afx_msg void OnUpdateRunPause(CCmdUI* pCmdUI);
	afx_msg void OnRunResume();
	afx_msg void OnUpdateRunResume(CCmdUI* pCmdUI);
	afx_msg void OnRunRun();
	afx_msg void OnUpdateRunRun(CCmdUI* pCmdUI);
	afx_msg void OnCloseAllWins();
	afx_msg void OnUpdateCloseAllWins(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg LRESULT OnUserInvalTop(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserCloseTop(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

private:
	double m_scalef;
	BOOL IsHScroll;
	BOOL IsDrawing;
	void PrintHeader(CDC* pDC);
	void DrawLine(CDC* pDC, int xp, int yp, int newx, int newy);
	void DrawName(CDC* pDC, int x, int y, Node* root);
	void DrawTreeInt(CDC* pDC, Node* root, double x, int y, double sf, 
					 int& ry, int& h, int dgap);
};

#ifndef _DEBUG  // debug version in TOPView.cpp
inline CGenericDoc* CTOPView::GetDocument()
   { return (CGenericDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
